# (C) http://spcms.ru

BEGIN {

    sub __cgi_carp_handle_errors {
        my $msg = shift;
        $msg =~ s|/var/www/cgi-bin/sp/||go;
        $msg =~
s/at (.+) line (\d+)/&mdash; <b style="color:#049">$1<\/b>  <b style="color:090">$2<\/b>/g;
        $msg =~ s/, near (.+)/ : <b>$1<\/b>/g;
        $msg =~ s/\n$//o;
        $msg =~ s/\n/<br><br>/go;
        $msg =~
s/Execution of (.+) aborted due to compilation errors\./ <b>$1<\/b> ./go;
        $msg =~
s/Global symbol &quot;([\$\@\%]\w+)&quot; requires explicit package name/<b style="color:red">$1<\/b>  /go;
        $msg =~ s/syntax error/ /go;
        $msg =~
s/Compilation failed in require/   <b style="color:red">require<\/b>/go;
        $msg =~
          s/Unmatched right square bracket/   /go;
        $msg =~
s/Type of arg 1 to push must be array/   push   /go;
        $msg =~ s/Not enough arguments for/  /go;
        $msg =~
s/Bareword (.+) not allowed while (.+) in use/ <b>$1<\/b>       <b>$2<\/b> (  \$, @  %?)/go;
        $msg =~ s/has too many errors/ &ndash;   /go;
        $msg =~ s/Too many arguments for/   /go;
        $msg =~ s/Illegal division by zero/  /go;
        $msg =~
          s/Illegal declaration of subroutine/  /go;
        $msg =~
s/Unmatched right curly bracket/   /go;
        $msg =~ s/at end of line/  /go;
        $msg =~
s/Might be a runaway multi-line (.+) string starting on line (\d+)/,   <b>$1<\/b>    <b>$2<\/b>/go;
        $msg =~
s/Undefined subroutine (.+) called/   $1/go;
        $msg =~ s/Unrecognized character/ /go;
        $msg =~
s/Can't modify constant item in scalar assignment/      /go;
        $msg =~
s/Can't use string \(&quot;(.+)&quot;\) as an? (.+) while &quot;(.+)&quot; in use/    <b>$1<\/b>  <b>$2<\/b>   <b>$3<\/b>/go;
        $msg =~
s/Can't use an undefined value as an ARRAY reference/     /go;
        $msg =~ s/\n/<br><br>/go;
        $msg =~
s/Can't call method &quot;(.+)&quot; on an undefined value/    <b>$1<\/b>   /go;
        exit print
q[<html><head><title>  -  </title><meta name="charset" content="windows-1251"><meta http-equiv="Content-Type" charset="windows-1251" content="text/html"></head>
<body bgcolor=#f5f5f5>
<table width=100% border=0 cellspacing=0 cellpadding=0>
<tr><td>
<div style="background:#fff;border:2px solid #d50;margin:18px 25px;padding:12px 16px;width:auto;font-family:'Lucida Console',monospace; border-radius: 7px;">
<table border=0 cellspacing=0 cellpadding=0>
<tr><td style="font: normal 11pt/1.1em 'Lucida Console', monospace;">
<h1 style="margin-bottom:16px; border-bottom: 1px dotted #ccc; font: normal 20pt/1.1em sans-serif;"></h1>
] . $msg
          . qq[<hr style="margin-top:2em">     <a href="//spcms.ru/contact"></a>.           .   ,     .
</td></tr></table>
</div>
</td></tr></table></body></html>];
    }
    CGI::Carp::set_message( \&__cgi_carp_handle_errors );
}

use DBI;
use POSIX qw(locale_h strftime LC_ALL ceil floor);
use CGI::Cookie;
use Time::Local;
use Time::HiRes;
use Compress::Zlib;
use IO::Socket::INET;
use Mail::Sender;
use Encode;
use LWP::UserAgent;
use locale;
use URI::Escape;
use Text::Iconv;
use Data::Dumper 'Dumper';
use strict;

sub error( $ );
sub tpl ( $ % );

our @wdays  = qw(      );
our @wdays2 = qw(      );
our @wdays2_from_monday = qw(      );
our @mnths =
  qw(           );
our ( $gpage, $DEBUG, %SQLH, $HTTP_HEADER_ADD, $g_sms_gate_url, $SQL_ERROR,
    $owner );

use vars
  qw/ $version %gconf $gdsn $gdb $gdbcms $gdate $queryes $gentime $guid $ggid
  $DEBUG $GZIP $connected %ACL %uid_to_gid_cache %uid_exists_in_ACL_cache
  $g_sms_gate_url $g_http_headers_sent
  @access_pupil @access_teacher @access_admin @exclude @months3
  $theme_dir $autor_insert
  /;

our $MOUName_short;

our @modules =
  qw(themes modules news mainmenu content loginform aboutou bdayinf lastcontent graduates
  search feedback administration rss rssform names namesfull actions account customblock customblock2
  customblock3 customblock4 analytics pmenu newsinf bellsinf bells bloginf settings
  gallery guestbook);

$version = '5.2.1';

$g_sms_gate_url = 'http://sms-gate.spcms.ru/smsc.cgi';

our $INCVER = $version . '.0';

$DEBUG = 0;

sub http_headers() {
    if ($g_http_headers_sent) {
        return;
    }

    if ($GZIP) { print "Content-Encoding: gzip\n"; }
    print "Cache-Control: no-cache\n";
    print $HTTP_HEADER_ADD;
    print "Content-Type: text/html; charset=windows-1251\n";
    print "Content-Language: ru\n";
    print "X-Powered-By: School Portal - www.spcms.ru\n\n";

    $g_http_headers_sent = 1;
}

sub setcookie {
    my $name    = shift;
    my $value   = shift;
    my $expires = shift;

    my $c = new CGI::Cookie(
        -name    => $name,
        -value   => $value,
        -expires => $expires,
    );
    $HTTP_HEADER_ADD .= "Set-Cookie: $c\n";
}

sub html_header() {
    my $title = ( defined $connected ) ? MOUName('short') : ' ';
    if ( $gconf{'light'} ) { $title = "  Light v$version"; }
    my $act       = param('act');
    my $autoclose = '';
    if (    $act
        and $act ne 'logout2'
        and grep( /^\Q$act\E$/, @access_admin )
        and !param('popup') )
    {
        $autoclose =
          ( $ENV{'HTTP_USER_AGENT'} =~ /MSIE/i )
          ? qq[ onunload="if (screenTop>9999) window.open('$gconf{"sp"}?act=logout2');"]
          : '';
    }
    $gpage = qq{<html><head><title>$title</title>
<meta name="keywords" content="  SP XXI CMS">
<meta name="copyright" content="Copyright (C) 2005-2012 www.spcms.ru">
<meta name="charset" content="windows-1251">
<meta name="pragma" content="no-cache">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
<link rel="shortcut icon" href="/sp/favicon.ico" type="image/x-icon">
<link rel="stylesheet" type="text/css" href="/sp/yui/menu/assets/skins/sam/menu.css?$INCVER">
<link rel="stylesheet" type="text/css" href="/sp/yui/assets/skins/sam/sp.css?$INCVER">
<link rel="stylesheet" type="text/css" href="/sp/style.css?$INCVER">
<!--[if IE 6]>
  <link rel="stylesheet" type="text/css" href="/sp/style-ie6.css?$INCVER">
<![endif]-->
<script type="text/javascript" src="/sp/ajax.js?$INCVER"></script>
<script type="text/javascript" src="/sp/yui/yahoo-dom-event/yahoo-dom-event.js?$INCVER"></script>
<script type="text/javascript" src="/sp/yui/container/container_core.js?$INCVER"></script>
<script type="text/javascript" src="/sp/yui/menu/menu.js?$INCVER"></script>
</head><body$autoclose>};
    if ($DEBUG) {
        $gpage .=
          qq[<script type="text/javascript" src="/sp/dump.js"></script>];
    }
}

sub generate_footers() {
    my ( $sec, $min, $hour, $mday, $mon, $year, $wday, undef, undef ) =
      localtime;
    $year += 1900;
    my $time = sprintf( "%02d:%02d", $hour, $min );
    my $datetime = "$wdays[$wday-1], $time<br>$mday $mnths[$mon] $year";

    my $footers =
      q[<table width='99%' cellspacing=0 cellpadding=0 class="footers">
<tr>];

    my $active_users_count = sqlff("select count(1) - 1 from sp_users_logged");
    my $column2_add        = '';

    my $searchfor = param("act");
    if ( $gdb and ( grep ( /^\Q$searchfor\E$/, @access_admin ) or param('edt') )
        or $ENV{'SCRIPT_NAME'} =~ m/msg.pl/ )
    {
        my $fio = sqlff(
            "select
'<b>'||last_name ||'</b><br>'|| first_name ||' '|| middle_name from human
where human_id = $guid"
        );
        my $t1 = declension( $active_users_count, [ '', '', '' ] );
        my $t2 = declension( $active_users_count, [ '',   '',  '' ] );

        if ( $ggid == 4 ) {
            $fio .= ' (' . get_pupil_class(1) . ')';
        }

        my $su_logout = '';
        if ( defined( cookie('su') ) ) {
            $su_logout =
qq[&nbsp;<a title="       " href="$gconf{sp}?act=su_logout">&times;</a>];
        }

        $footers .= "<td class=footer_fio>$fio$su_logout</td>";

        $column2_add =
          "<br>   $t1 $active_users_count $t2"
          if ($active_users_count);
    }

    my $product_name =
      $gconf{'light'} ? '  Light' : ' ';

    $footers .= qq[
<td class="footer_col2">
	&copy; <a href="http://spcms.ru/" target="_blank">$product_name</a> v$version
	$column2_add
</td>

<td class="footer_col3">$datetime</td>

<td class="footer_col4">
		<a href='#' onclick="javascript:print(); return false;" title=" "><img src="/sp/img/footer_print.png"></a>
</td>

</tr>
</table>
];

    return $footers;

}

our $login_form =
qq[<form action="/cgi-bin/sp/sp.cgi" name="login_form" method="post" OnSubmit="document.login_form.sbmt.disabled = true; return true;">
<input type=hidden name=act value=login>
<table border="0" cellspacing="0" cellpadding="0" class=debug align=center>
<tr><th class=debug colspan=2></th></tr>
<tr>
<td class=fields1> :</td>
<td class=fields1><input type=text class=def name=log size=20></td>
</tr>
<tr>
<td class=fields>:</td>
<td class=fields><input type=password class=def name=pwd size=20></td>
</tr>
<tr>
<td class=td_for_submit colspan=2>
<button name=sbmt type=submit value="send"><img src="/sp/img/ok.gif" width="16" height="16" align=absmiddle>&nbsp;</button>&nbsp;&nbsp;<button type="reset"><img src="/sp/img/reload.gif" width="16" height="16" align=absmiddle>&nbsp;</button>
</td></tr></table></form>
<script type="text/javascript">document.login_form.log.focus();document.login_form.log.select();</script>];

sub session_check {
    my $numeric_result = shift;

    my $sid = cookie("sp_sid");

    unless ($sid) {

        if ($numeric_result) {
            return 0;
        }

        error(
qq[      .<br><br> :
<ul>
<li>  .     ,    (,  ,             Opera  Firefox,         ).
<li>       Cookies,    proxy-  firewall,     .
</ul>
  ,     .<br><br>
$login_form
<br>
  , :
<ul>
<li>     Cookies   .
<li> .
<li>  Cookies  proxy-  firewall'.
<li>        ,         .
</ul>
        ,
    ,  <a href="/">   </a>.
		]
        );
    }
    else {
        sec_gt0($sid);
    }

    my @logged_info = sqlf(
        "select lasttime, ip, ip_for, agent
from   sp_users_logged
where  sid = $sid"
    );

    unless (@logged_info) {

        if ($numeric_result) {
            return 0;
        }

        session_expired();
    }

    my $ip     = $ENV{'REMOTE_ADDR'};
    my $ip_for = substr( $ENV{'HTTP_X_FORWARDED_FOR'} || '', 0, 40 );
    my $agent  = substr( $ENV{'HTTP_USER_AGENT'}, 0, 127 );
    my $now    = timelocal(localtime);

    if ( defined $gconf{'skip_session_ip_check'} ) {
        my $re = $gconf{'skip_session_ip_check'};
        $re =~ s/[^\d\.*]//g;
        $re =~ s/\./\\./g;
        $re =~ s/\*/[\\d.]+/;

        if ( $logged_info[1] =~ m/^$re$/ ) {
            if ( $logged_info[3] ne $agent ) {

                if ($numeric_result) {
                    return 0;
                }

                not_logged();
            }
        }
        else {
            if (   $logged_info[1] ne $ip
                or $logged_info[2] ne $ip_for
                or $logged_info[3] ne $agent )
            {

                if ($numeric_result) {
                    return 0;
                }

                not_logged();

            }
        }

    }
    else {

        if (   $logged_info[1] ne $ip
            or $logged_info[2] ne $ip_for
            or $logged_info[3] ne $agent )
        {

            if ($numeric_result) {
                return 0;
            }

            not_logged();

        }

    }

    if ( $now - $logged_info[0] > $gconf{'session_idle_max'} ) {

        if ($numeric_result) {
            return 0;
        }

        session_expired();
    }

    return 1;

}

sub not_logged() {
    my $path = ( $ENV{'SCRIPT_NAME'} =~ m/cms\.pl/ ) ? ".." : ".";
    tpl "$path/tpl/error.html", {
        title => '    .',
        msg   => qq[   (   ,    )
         .<br><br>
   (     )
   .<br><br>$login_form]
    };
}

sub session_expired() {
    my $path = ( $ENV{'SCRIPT_NAME'} =~ m/cms\.pl/ ) ? ".." : ".";
    tpl "$path/tpl/error.html", {
        title => '  .',
        msg   => qq[     .<br>
  ,     .<br><br>
$login_form<br>
<a href="/">  </a>]
    };
}

sub session_keep_alive() {
    my $sid = sid();
    my $now = timelocal(localtime);

    my $r =
      $gdb->do("update sp_users_logged set LASTTIME = $now where sid = $sid");
    unless ( $r == -1 ) {
        my $retry_count = 0;
        while (1) {
            $retry_count++;
            last if $retry_count > 10;
            last
              if -1 == $gdb->do(
"update sp_users_logged set LASTTIME = $now where sid = $sid"
              );
            Time::HiRes::sleep(0.05);
        }
    }
}

sub session_access() {
    my $act = param('act');

    my $denied = 1;

    if ( $ggid == 0 ) { return }

    if ( $ggid == 4 ) { $denied = 0 if ( grep /^\Q$act\E$/, @access_pupil ); }

    if ( $ggid == 2 ) { $denied = 0 if ( grep /^\Q$act\E$/, @access_teacher ); }

    if ( $ggid == 1 ) { $denied = 0 if ( grep /^\Q$act\E$/, @access_admin ); }

    deny() if $denied;
}

sub deny() {
    tpl './tpl/deny.html',
      {
        menu    => generate_menu(),
        footers => generate_footers()
      };
}

sub sid() {
    my $sid = cookie("sp_sid")
      || error
"     ,      cookies.     ,     .    ,       ,    .<br><br>$login_form";
    sec_gteq0($sid);
    return $sid;
}

sub uid() {
    my $sid = sid();
    my $a   = sqlff(
        "select sp_users.uid from sp_users, sp_users_logged
where sp_users_logged.sid = '$sid'
and sp_users.uid = sp_users_logged.uid"
    );
    if ( defined $a ) { return $a }
    else {
        session_expired();
    }
}

sub uid_gid_gdate() {
    my $sid = sid();

    my @a = sqlf(
        "select sp_users.uid, sp_users.gid, sp_users.state_date,
(select property_value from self_property where name='SHORT_ORG_NAME')
from   sp_users, sp_users_logged
where  sp_users.uid = sp_users_logged.uid
       and sp_users_logged.sid = '$sid'"
    );

    if (@a) {
        $MOUName_short = $a[3];

        if ( defined($ggid) and $ggid == 0 ) {
            my $su_UID = cookie('su');

            if ( defined($su_UID) ) {
                if ( $su_UID =~ m/^\d+$/ ) {
                    my ( $tmp_gid, $tmp_state_date ) = sqlf(
                        "select gid, state_date
							from sp_users where uid = $su_UID"
                    );
                    $a[0] = $su_UID;
                    $a[1] = $tmp_gid;
                    $a[2] = $tmp_state_date;
                    ;
                }
            }
        }

        return @a;
    }
    else {
        error
qq[  .     .  008215. <a href="$gconf{'sp'}?act=login_form"></a>];
    }
}

our %uid_to_gid_cache;

our %uid_exists_in_ACL_cache;

sub gid {
    return -1 if !defined $gdb;

    my $uid = shift;
    my $gid = shift;

    my $detected_gid;

    unless ($uid) {

        my $sid = sid();

        $detected_gid = sqlff(
            "select sp_users.gid from sp_users, sp_users_logged
		where sp_users_logged.sid = '$sid'
		and sp_users.uid = sp_users_logged.uid"
        );

        if ( $detected_gid == 2 ) {
            if (
                1 == sqlff(
                    "select sp_users_acl.gid from sp_users_acl, sp_users_logged
					where sp_users_logged.sid = '$sid'
					and sp_users_acl.uid = sp_users_logged.uid and sp_users_acl.gid = 1"
                )
              )
            {
                $detected_gid = 1;
            }
        }

    }
    else {

        unless ( exists $uid_to_gid_cache{$uid} ) {
            $uid_to_gid_cache{$uid} =
              sqlff("select gid from sp_users where uid = $uid");
        }

        $detected_gid = $uid_to_gid_cache{$uid};

        if ( $detected_gid == 2 ) {
            if (
                1 == sqlff(
                    "select gid
					from    sp_users_acl
					where   uid = $uid
							and
							sp_users_acl.gid = 1"
                )
              )
            {
                $detected_gid = 1;
            }
        }
        elsif ( defined($gid) ) {
            if ( exists $uid_exists_in_ACL_cache{"$uid,$gid"} ) {
                return $uid_exists_in_ACL_cache{"$uid,$gid"};
            }

            if (
                sqlff(
                    "select 1
					from    sp_users_acl
					where   uid = $uid
							and
							sp_users_acl.gid = $gid"
                )
              )
            {
                $uid_exists_in_ACL_cache{"$uid,$gid"} = 1;

                return 1;
            }
        }

        if ( defined($gid) ) {
            unless ( exists $uid_exists_in_ACL_cache{"$uid,$gid"} ) {
                $uid_exists_in_ACL_cache{"$uid,$gid"} =
                  ( $gid == $detected_gid ) ? 1 : 0;
            }

            return ( $gid == $detected_gid ) ? 1 : 0;
        }

    }

    if ( defined $detected_gid ) {
        return $detected_gid;
    }
    else {

        security_alert( "uid=$uid", '   ' );
    }

}

sub su() {
    my $u = substr( param('u'), 0, 63 );

    my $new_uid = sqlbff(
        "select first 1 uid from sp_users
where sp_users.uid = ? or sp_users.log = ?", $u, $u
    );

    if ($new_uid) {
        setcookie( 'su', $new_uid, '+24H' );
        msg(
            q[   <br>   ],
q[ .<br><br>     .    ,               .<br><br><input type='button' value='' onclick='redir("?act=main")'>]
        );
    }
    else {
        stop("  .");
    }
}

sub su_logout() {
    if ( defined( cookie('su') ) ) {
        setcookie('su');
    }
    else {
        security_alert( '', 'su_logout() called wothout su cookie' );
    }

    redir("$gconf{sp}?act=main");
}

sub gname() {

    my $q = sqlp("select NAME from SP_GID_REF where GID = $ggid");
    my @a = $q->fetchrow_array();
    $q->finish();
    if   ( $a[0] ) { return $a[0] }
    else           { error " :  1" }
}

sub fio {
    my $ref = $_[0];
    my $uid = $_[1] || $guid;
    my $q   = sqlp(
        "select human.last_name, human.first_name, human.middle_name
from human where human_id = $uid"
    );
    @$ref = $q->fetchrow_array();
    $q->finish();
}

our ( %human_hash, %human_hash_ini );

sub human_hash {
    my $id_human = shift;
    my $type = shift || 0;

    if ( $id_human > 0 ) {

        if ( $type == 1 ) {
            $human_hash_ini{$id_human} = trim(
                sqlff(
q[SELECT human.last_name ||' '|| substr(human.first_name,1,1) ||'. '|| substr(human.middle_name,1,1) ||'.' FROM human WHERE human_id = ]
                      . $id_human
                )
            ) unless exists $human_hash_ini{$id_human};

            if ( !defined $human_hash_ini{$id_human} ) {
                $human_hash_ini{$id_human} = "&mdash;";
            }

            return $human_hash_ini{$id_human};
        }
        else {
            $human_hash{$id_human} = trim(
                sqlff(
q[SELECT human.last_name ||' '|| human.first_name ||' '|| human.middle_name FROM human WHERE human_id = ]
                      . $id_human
                )
            ) unless exists $human_hash{$id_human};

            if ( !defined $human_hash{$id_human} ) {
                $human_hash{$id_human} = "&mdash;";
            }

            return $human_hash{$id_human};
        }

    }
    elsif ( $id_human == -1 ) {
        return '';
    }
    else {
        return '&mdash;';
    }

}

sub clear_expired_sessions() {
    my $now = timelocal(localtime);
    my $r   = $gdb->do(
        "delete from sp_users_logged
                    where $now - lasttime > " . $gconf{"session_idle_max"}
    );
    unless ( $r == -1 ) {
        my $retry_count = 0;
        while (1) {
            $retry_count++;
            last if $retry_count > 10;
            last if -1 == $gdb->do(
                      "delete from sp_users_logged where
                              $now - lasttime > " . $gconf{"session_idle_max"}
            );
            Time::HiRes::sleep(0.05);
        }
    }
}

our $__sql_time;

sub __sql_prolog() {
    $__sql_time = Time::HiRes::time();
}

sub __sql_epilog($) {
    $__sql_time = sprintf( "%.03f", Time::HiRes::time() - $__sql_time );
    $__sql_time =~ s/,/./;
    ${ $_[0] } .= qq[\n<b class=tot_freed>$__sql_time</b> ];
    $queryes++;
    if ( $__sql_time > 0.1 ) {
        ${ $_[0] } =
          qq[<span style="background-color:rgb(254,249,214)">${$_[0]}</span>];
    }
    ${ $_[0] } =~ s/[\t ]+/ /g;
    $SQLH{ ${ $_[0] } }++;
}

sub __sql_epilog_cms($) {
    $__sql_time = sprintf( "%.03f", Time::HiRes::time() - $__sql_time );
    $__sql_time =~ s/,/./;
    ${ $_[0] } .= qq[\n<b class=tot_freed>$__sql_time</b> ];
    $queryes++;
    if ( $__sql_time > 0.1 ) {
        ${ $_[0] } =
          qq[<span style="background-color:rgb(254,249,214)">${$_[0]}</span>];
    }
    ${ $_[0] } =~ s/[\t ]+/ /g;
    $SQLH{"<p>${$_[0]}</p>"}++;
}

sub sql($) {
    my $sql = shift;
    __sql_prolog() if $DEBUG;

    $gdb->do($sql) or report_sql_error($sql);

    __sql_epilog( \$sql ) if $DEBUG;
}

sub sqlp {
    my $sql  = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdb->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    __sql_epilog( \$sql ) if $DEBUG;
    return $q;
}

sub sqlpb {
    my $sql  = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdb->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    __sql_epilog( \$sql ) if $DEBUG;
    return $q;
}

sub sqlf {
    my $sql  = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdb->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    my @a = $q->fetchrow_array();
    $q->finish;
    __sql_epilog( \$sql ) if $DEBUG;
    return @a;
}

sub sqlfb {
    my $sql    = shift;
    my @values = @_;

    my $attr;

    if ( 'HASH' eq ref( $values[-1] ) ) {
        $attr = pop @values;
    }

    __sql_prolog() if $DEBUG;

    my $q = $gdb->prepare( $sql, $attr ) or report_sql_error($sql);

    $q->execute(@_) or report_sql_error($sql);
    my @a = $q->fetchrow_array();

    $q->finish;

    __sql_epilog( \$sql ) if $DEBUG;

    return @a;
}

sub sqlfbcms {
    my $sql    = shift;
    my @values = @_;

    my $attr;

    if ( 'HASH' eq ref( $values[-1] ) ) {
        $attr = pop @values;
    }

    __sql_prolog() if $DEBUG;

    my $q = $gdbcms->prepare( $sql, $attr ) or report_sql_error($sql);

    $q->execute(@_) or report_sql_error($sql);
    my @a = $q->fetchrow_array();

    $q->finish;

    __sql_epilog_cms( \$sql ) if $DEBUG;

    return @a;
}

sub sqlfr($) {
    my $sql = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdb->prepare($sql) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    my $aref = $q->fetchrow_arrayref();
    $q->finish;
    __sql_epilog( \$sql ) if $DEBUG;
    return $aref;
}

sub sqlffa($$) {
    my $ref = shift;
    my $sql = shift;

    __sql_prolog() if $DEBUG;

    my $q = $gdb->prepare($sql) or report_sql_error($sql);

    $q->execute() or report_sql_error($sql);

    my $arrayref;

    while ( defined( $arrayref = $q->fetchrow_arrayref ) ) {
        push @{$ref}, $$arrayref[0];
    }

    $q->finish;

    __sql_epilog( \$sql ) if $DEBUG;
}

sub sqlh($$) {
    my $hash_ref = shift;
    my $sql      = shift;
    my ( $id, $value );
    __sql_prolog() if $DEBUG;
    my $q = $gdb->prepare($sql) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    while ( ( $id, $value ) = $q->fetchrow_array ) {
        ${$hash_ref}{$id} = $value;
    }
    $q->finish;
    __sql_epilog( \$sql ) if $DEBUG;
}

sub sqlhcms($$) {
    my $hash_ref = shift;
    my $sql      = shift;
    my ( $id, $value );
    __sql_prolog() if $DEBUG;
    my $q = $gdbcms->prepare($sql) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    while ( ( $id, $value ) = $q->fetchrow_array ) {
        ${$hash_ref}{$id} = $value;
    }
    $q->finish;
    __sql_epilog_cms( \$sql ) if $DEBUG;
}

sub sqla {
    my $a_ref = shift;
    my $sql   = shift;
    my $attr  = shift;
    my (@a);
    __sql_prolog() if $DEBUG;
    my $q = $gdb->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute(@_) or report_sql_error($sql);
    while ( @a = $q->fetchrow_array ) { push @{$a_ref}, [@a]; }
    $q->finish;
    __sql_epilog( \$sql ) if $DEBUG;
}

sub sqlff {
    my $sql  = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdb->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    my $a = ( $q->fetchrow_array() )[0];
    $q->finish;
    __sql_epilog( \$sql ) if $DEBUG;
    return $a;
}

sub error($) {
    my $error_str  = shift;
    my $stacktrace = '';
    if ($DEBUG) {
        $stacktrace = '<hr>'
          . Carp::longmess(
            '<pre>   (-):<br><br>');
        $stacktrace =~ s/\t/ /go;
        $stacktrace =~ s/at (.[^\s]+) line (\d*)/&bull; $1\t: $2/o;
        $stacktrace =~ s|/var/www/cgi-bin/sp/||go;
        $stacktrace =~ s|main::(\w+).+at( .+\..+)line(.+)|^$2\t:$3\t$1()|g;
    }

    my $m = $gconf{'cms'} || '/cms.pl';
    my $path =
      $ENV{"SCRIPT_FILENAME"} =~ m/$m$/
      ? '../tpl/error.html'
      : './tpl/error.html';

    tpl( $path,
        { 'title' => '!', 'msg' => ( $error_str . $stacktrace ) } );

}

sub stop($) {
    my $error_str  = shift;
    my $stacktrace = '';

    if ($DEBUG) {
        $stacktrace =
          '<hr style="margin-top:1em">'
          . Carp::longmess(
            '<pre>   (-):<br><br>');
        $stacktrace =~ s/\t/ /go;
        $stacktrace =~ s/at (.[^\s]+) line (\d*)/&middot; $1\t: $2/o;
        $stacktrace =~ s|/var/www/cgi-bin/sp/||go;
        $stacktrace =~ s|main::(\w+).+at( .+\..+)line(.+)|^$2\t:$3\t$1()|g;

        $stacktrace .= '</pre>';

        not defined($error_str)
          and $error_str =
          ' stop()  <span style="color:red">undef</span>';
    }

    my $m = $gconf{'cms'} || '/cms.pl';
    my $path =
      $ENV{"SCRIPT_FILENAME"} =~ m/$m$/
      ? '../tpl/stop.html'
      : './tpl/stop.html';

    tpl( $path, { 'msg' => ( $error_str . $stacktrace ) } );
}

sub db_error() { report_sql_error(0); }

sub db_error_connect {

    my $baseName = $_[0] || 1;

    my %BaseNames = (
        1 => '&laquo; &raquo;',
        2 => '&laquo;   &raquo;',
        3 => '&laquo;   &raquo;',
        4 => '&laquo; &raquo;'
    );

    error(
        qq[
  .<br><br>
     $BaseNames{$baseName}.<br>
<UL>
<LI>  ,    
	  ,   
	 .</LI>
<LI>  ,  <a href="http://wiki.spcms.ru/____" target="_blank">
	  </a>.</LI>
</UL>
] . ( $DEBUG ? "<pre>DBI:\n$DBI::errstr</pre>" : '' )
    );
}

sub tpl ( $ % ) {
    my $file = $_[0];
    my $ref  = $_[1];

    unless ( -e $file ) {
        $file =~ s/\.\././;
        unless ( -e $file ) {
            $file = '/var/www/cgi-bin/sp/' . $file;
        }
    }

    open F, "<$file" or aj_print(" <b>$file</b>  </body></html>");
    my $tpl = join '', <F>;
    close F;

    http_headers();
    html_header();

    if ($DEBUG) {
        my $speedy =
          ($CGI::SpeedyCGI::i_am_speedy)
          ? qq[<span style="color:#11a;">on</span>]
          : '<span style="color:#b11;">off</span>';
        my $mod_perl = exists $ENV{'MOD_PERL'} ? 1 : 0;
        $gentime ||= 0;
        $gentime = sprintf( "%.02f", Time::HiRes::time() - $gentime );
        $gpage .= qq[<div align=center class=dontprint>
<a href="#a_sp_sql_dump" onclick="e('sp_sql_dump').style.display = 'block';"><span style="color:green">SQL</span>: <b>$queryes</b></a> | time: <b>$gentime</b> | speedy = <b>$speedy</b> | mod_perl = $mod_perl</div>
];
    }

    if ($ref) {
        my ( $key, $value );
        while ( ( $key, $value ) = each(%$ref) ) {
            $tpl =~ s/\$$key\b/$value/gi;
        }
        $gpage .= $tpl;
    }
    else {
        $gpage .= $tpl;
    }

    $gpage =~ s/\$INCVER\b/$INCVER/gi;

    if ($DEBUG) {
        $gpage .= qq[<div class=dontprint style="display:none" id="sp_sql_dump">
		<a name="a_sp_sql_dump"></a><h1>SQL- ($queryes)</h1>];
        for ( sort keys %SQLH ) {
            $gpage .= qq[<div class=sql>];
            if ( $SQLH{$_} > 1 ) {
                $gpage .=
qq[<div><u><b>!</b>   &ndash; <b style="color:red">$SQLH{$_}</b></u></div>];
            }
            $gpage .= qq[<pre>$_</pre></div>];
        }
        $gpage .= '</div>';
    }

    $gpage .= '</body></html>';

    if ( param('popup') ) {
        $gpage =~ s|</form>|<input type=hidden name=popup value=1></form>|gi;
    }

    if ($GZIP) {
        binmode(STDOUT);
        print Compress::Zlib::memGzip($gpage);
    }
    else {
        print $gpage;
    }

    exit;
}

sub tpl_str ( $ % ) {
    my $file    = $_[0];
    my $ref     = $_[1];
    my $tpl_str = "";

    open F, "<$_[0]" or aj_print(" <b>$_[0]</b>  </body></html>");
    my @tpl = <F>;
    close F;
    my $tpl = join '', @tpl;

    if ($ref) {
        my ( $key, $value );
        while ( ( $key, $value ) = each(%$ref) ) {
            $tpl =~ s/\$$key\b/$value/gi;
        }
        $tpl_str .= $tpl;
    }
    else {
        $tpl_str .= $tpl;
    }
    $tpl_str =~ s/\$INCVER\b/$INCVER/gi;

    return $tpl_str;
}

sub printfile ( $ ) {
    my $m = $gconf{'sp'};
    if ( $ENV{"SCRIPT_FILENAME"} =~ m/$m$/ ) { http_headers() }
    open FILE, "<$_[0]";
    while (<FILE>) { $gpage .= $_ }
    close FILE;
    if ($GZIP) { binmode(STDOUT); print Compress::Zlib::memGzip($gpage); }
    else       { print $gpage; }
    exit;
}

sub read_config($) {
    my %config;
    open CONFIG, "<", "$_[0]"
      or aj_print("   .<br>\n = $_[0]<br>$!\n");
    while (<CONFIG>) {
        chomp;
        s/#.*//;
        s/^\s+//;
        s/\s+$//;
         next unless length;
        my ( $var, $value ) = split( /\s*=\s*/, $_, 2 );
        $config{$var} = $value;
    }
    close CONFIG;

    $DEBUG = $config{'DEBUG'};
    $GZIP  = $config{'site_gzip'};

    return (%config);
}

sub totime($) {
    my ( $d, $m, $y ) = split /\./, $_[0];
    unless ( $m and $y ) {
        security_alert( $_[0], qq[totime() parameter is not 'DD.MM.YYYY'] );
    }
    return timelocal( undef, undef, undef, $d, $m - 1, $y );
}

sub todate($) {

    my ( undef, undef, undef, $d, $m, $y, undef, undef, undef ) =
      localtime shift;

    $y += 1900;
    $m++;

    return sprintf "%02d.%02d.%04d", $d, $m, $y;
}

sub todatetime($) {
    my ( $S, $M, $H, $d, $m, $y, undef, undef, undef ) = localtime shift;

    $y += 1900;
    $m++;

    return sprintf "%02d.%02d.%04d %02d:%02d:%02d", $d, $m, $y, $H, $M, $S;
}

sub time2unix($) {
    my ( $hh, $mm, $ss ) = split /:/, $_[0];
    $ss ||= 0;
    return timelocal( $ss, $mm, $hh, 1, 0, 1970 );
}

sub unix2time($) {
    my ( $S, $M, $H, undef, undef, undef, undef, undef, undef ) = gmtime shift;
    return sprintf( "%02d:%02d:%02d", $H, $M, $S );
}

sub date {
    my $tm = $_[0];
    unless ( defined $tm ) { return time; }
    my ( $s, $i, $G, $j, $n, $Y, $w, $z, $isdst ) =
      ( defined $_[1] ? $_[1] : localtime );

    $Y += 1900;
    $n++;

    my $y = substr( $Y, 2, 3 );
    my $m = sprintf "%02d", $n;
    my $d = sprintf "%02d", $j;
    my $H = sprintf "%02d", $G;
    $s = sprintf "%02d", $s;
    $i = sprintf "%02d", $i;

    $tm =~ s/z/$z/g;
    $tm =~ s/Y/$Y/g;
    $tm =~ s/y/$y/g;
    $tm =~ s/n/$n/g;
    $tm =~ s/m/$m/g;
    $tm =~ s/j/$j/g;
    $tm =~ s/d/$d/g;
    $tm =~ s/s/$s/g;
    $tm =~ s/i/$i/g;
    $tm =~ s/G/$G/g;
    $tm =~ s/H/$H/g;
    $tm =~ s/w/$w/g;

    return $tm;
}

sub day_add {
    my $count = $_[1] || 1;
    $_[0] += 86400 * $count;
           return $_[0];
}

sub day_sub {
    my $count = $_[1] || 1;
    $_[0] -= 86400 * $count;
           return $_[0];
}

sub DaysInMonth($$) {
    my $month = int(shift);
    my $year  = shift;

    if (   $month == 1
        or $month == 3
        or $month == 5
        or $month == 7
        or $month == 8
        or $month == 10
        or $month == 12 )
    {
        return 31;
    }

    if ( $month == 4 or $month == 6 or $month == 9 or $month == 11 ) {
        return 30;
    }

    return 28 + IsLeapYear($year);
}

sub IsLeapYear($) {
    my $year = shift;

    if ( $year % 4 == 0
        and ( $year % 100 != 0 or $year % 400 == 0 ) )
    {
        return 1;
    }
}

sub MOUName {
    unless (
        sqlff(
q[select 1 from RDB$RELATIONS where RDB$RELATION_NAME = 'SELF_PROPERTY']
        )
      )
    {
        return undef;
    }

    my ( $ou_name, $ou_all, $flag );
    unless ( $_[0] ) {

        $ou_all = sqlff(
"select property_value from self_property where name = 'SHORT_ORG_NAME'"
        );
        return ( $ou_all, '' );
    }
    elsif ( $_[0] eq 'short' ) {
        if ( defined $MOUName_short ) {
            return $MOUName_short;
        }
        $ou_name = sqlff(
"select PROPERTY_VALUE from SELF_PROPERTY where name='SHORT_ORG_NAME'"
        );
        $MOUName_short = $ou_name;
        return $ou_name;
    }
    elsif ( $_[0] eq 'full' ) {
        $ou_name = sqlff(
"select PROPERTY_VALUE from SELF_PROPERTY where name='ORGANIZATION_NAME'"
        );
        return $ou_name;
    }
}

sub get_pupil_class {
    return undef if $gconf{'light'};

    my $mode       = shift;
    my $uid        = shift || $guid;
    my $dont_clean = shift || 0;
    my ( $q, $c );
    if ( $mode == 0 ) {
        $c = sqlff(
            "select distinct class.class_id
from   sys_matrix, class
where  sys_matrix.view_class = 1 and
       class.class_id = sys_matrix.class and
       sys_matrix.vw_pupil = $uid and
       exists ( select 1 from get_node_saldo(sys_matrix.node_id,
               '$gdate', 0) where saldo_sum <> 0 ) "
        );
        if ( !$c and $ggid == 4 ) {
            my $tmp =
              sqlff "select max(entry_date) from sys_entry t1, sys_matrix t2
where t1.credit_node = t2.node_id and
entry_date between (select min(entry_date) from sys_entry) and '$gdate' and
doc_class = 5 and
vw_pupil = $uid", { ib_timestampformat => '%d.%m.%Y' };
            if ($tmp) {
                $gdate = todate( day_sub( totime($tmp) ) );
                $c     = sqlff(
                    "select distinct class.class_id
from   sys_matrix, class
where  sys_matrix.view_class = 1 and
       class.class_id = sys_matrix.class and
       sys_matrix.vw_pupil = $uid and
       exists ( select 1 from get_node_saldo(sys_matrix.node_id,
               '$gdate', 0) where saldo_sum <> 0 ) "
                );
            }
            else {

                return 'ID   ';
            }
        }
    }
    else {
        my $class = get_pupil_class( 0, $uid );

        my $startdate = aboutouStartDate();
        if (
            sqlff "select 1 from sys_entry t1, sys_matrix t2
  where t1.credit_node = t2.node_id and
    entry_date between '$startdate' and '$gdate' and
    doc_class = 5 and
    vw_pupil = $uid and
    exists(select 1 from doc_deduction_order_sp where doc_no = t1.doc and human_id = t2.vw_pupil and
    deduction_type between 1032 and 1034)"
          )
        {
            return '';
        }

        return '  ' if $class eq 'ID   ';

        return '  ' unless $class;

        $q = sqlp(
            "  select
      paralel ||'&nbsp;'|| (select name from class where class_id = cast(sys_matrix.class as integer))
    from
      class, sys_matrix
    where
      class_id = $class
      and sys_matrix.class = class_id
      and sys_matrix.view_class = 7
      and exists ( select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)"
        );
        $c = ( $q->fetchrow_array() )[0] || " :  2";

        unless ($dont_clean) {

            $c =~ s/(\s*".+").+$/$1/;
            $c =~ s/\"/&quot;/go;
        }

        $q->finish;
    }
    return $c;
}

sub resolve_class_id($) {
    my $id = shift;
    sec_gt0($id);
    my $dont_clean = shift || 0;

    my $class_name = sqlff "select sys_matrix.paralel || '&nbsp;'
|| ( select class.name from class where class.class_id = sys_matrix.class )
from   sys_matrix
where  sys_matrix.view_class = 7 and
       sys_matrix.class = $id and
       exists ( select 1 from get_node_saldo(sys_matrix.node_id,
               '$gdate', 0) where saldo_sum <> 0 )";

    unless ($dont_clean) {
        $class_name =~ s/(.+\").+/$1/;
        $class_name =~ s/\"/&quot;/go;
    }

    return $class_name;
}

sub trim(@) {
    my @out = @_;

    for (@out) {
        !defined($_) and next;
        s/^\s+//;
        s/\s+$//;
    }

    return @out == 1 ? $out[0] : @out;
}

sub dmp { stop( '<pre>' . ( Dumper(shift) ) . '</pre>' ); }
sub pdump { print Dumper(shift); }

sub dmp_param {
    my @params;
    for ( param() ) {
        push @params, [ $_, param($_) ];
    }
    dmp2d( \@params );

}

sub dmp2d {
    my $ref = shift;
    my $n   = @$ref;

    my $style;
    my $t            = '';
    my $max_cols     = 0;
    my $current_cols = 0;
    for my $i (@$ref) {
        $t .= '<tr>';
        for ( @{$i} ) {
            $style = '';
            if ( !defined ) {
                $style = 'color:red';
                $_     = 'NULL';
            }
            elsif (/^\d+$/) {
                $style = 'color:green';
            }
            if ( defined and $_ eq '' ) {
                $style = 'background-color:#fafafa';
                $_     = '&nbsp;';
            }
            $t .= qq[<td style="$style">$_</td>];
            $current_cols++;
        }
        if ( $max_cols < $current_cols ) { $max_cols = $current_cols; }
        $current_cols = 0;
        $t .= '</tr>';
    }

    my $head =
qq[<style type="text/css">.d tr td {font-size:13pt;font-family:'Droid Sans Mono','Lucida Console',monospace;}</style>
<h2 style="text-align:left">   ($n )</h2>
<table class=d cellspacing=0 cellpadding=4>
<tr>];

    for ( my $i = 0 ; $i < $max_cols ; $i++ ) {
        $head .= qq[<th>\$\$_[$i]</th>];
    }

    $t = qq[$head</tr>$t</table>];
    stop($t);
}

sub aj_print($) {
    http_headers();
    if ($GZIP) {
        binmode(STDOUT);
        print Compress::Zlib::memGzip(shift);
    }
    else {
        print shift;
    }
    exit;
}

sub ConnectDBCms {
    if ( !defined($gdbcms) or !$gdbcms->ping ) {

        $gdsn =
            "DBI:InterBase:db="
          . $gconf{"cmsdbname"}
          . ";ib_charset=WIN1251;ib_dialect=3;host="
          . $gconf{"cmsdbhost"};
        $gdbcms =
          DBI->connect( $gdsn, $gconf{"cmsdbuser"}, $gconf{"cmsdbpasswd"} )
          or db_error_connect(2);

        $gdbcms->{FetchHashKeyName} = 'NAME_lc';

        $gdbcms->{LongReadLen} = '500000';
        $gdbcms->{LongTruncOk} = 1;
    }
}

sub sqlcms($) {
    my $sql = shift;
    __sql_prolog() if $DEBUG;

    $gdbcms->do($sql) or report_sql_error($sql);

    __sql_epilog_cms( \$sql ) if $DEBUG;
}

sub sqlfcms { my $sql = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdbcms->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    my @a = $q->fetchrow_array();
    $q->finish;
    __sql_epilog_cms( \$sql ) if $DEBUG;
    return @a;
}
sub sqlffcms { my $sql = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdbcms->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    my $a = ( $q->fetchrow_array() )[0];
    $q->finish;
    __sql_epilog_cms( \$sql ) if $DEBUG;
    return $a;
}

sub sqlffacms($$) {
    my $ref = shift;
    my $sql = shift;

    __sql_prolog() if $DEBUG;

    my $q = $gdbcms->prepare($sql) or report_sql_error($sql);

    $q->execute() or report_sql_error($sql);

    my $arrayref;
    while ( defined( $arrayref = $q->fetchrow_arrayref ) ) {
        push @{$ref}, $$arrayref[0];
    }

    $q->finish;

    __sql_epilog_cms( \$sql ) if $DEBUG;
}

sub sqlpcms { my $sql = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdbcms->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    __sql_epilog_cms( \$sql ) if $DEBUG;
    return $q;
}

sub sqlb {
    my $sql    = shift;
    my @values = @_;
    __sql_prolog() if $DEBUG;

    $gdb->do( $sql, undef, @values ) or report_sql_error($sql);

    __sql_epilog( \$sql ) if $DEBUG;
}

sub sqlbff {
    my $sql    = shift;
    my @values = @_;

    my $attr;
    if ( 'HASH' eq ref( $values[-1] ) ) {
        $attr = pop @values;
    }

    __sql_prolog() if $DEBUG;

    my $q = $gdb->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute(@_) or report_sql_error($sql);
    my $a = ( $q->fetchrow_array() )[0];
    $q->finish();

    __sql_epilog( \$sql ) if $DEBUG;

    return $a;
}

sub sqlbcms {
    my $sql    = shift;
    my @values = @_;
    __sql_prolog() if $DEBUG;

    $gdbcms->do( $sql, undef, @values ) or report_sql_error($sql);

    __sql_epilog_cms( \$sql ) if $DEBUG;
}

sub sqlbfcms {
    my $sql    = shift;
    my @values = @_;
    my $attr;
    if ( 'HASH' eq ref( $values[-1] ) ) {
        $attr = pop @values;
    }
    __sql_prolog() if $DEBUG;
    my $q = $gdbcms->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute(@_) or report_sql_error($sql);
    my @a = $q->fetchrow_array();
    $q->finish();
    __sql_epilog_cms( \$sql ) if $DEBUG;
    return @a;
}

sub cmsgenid {
    my $gen = shift;
    my $inc = shift || 0;

    return sqlffcms "SELECT gen_id($gen, $inc) FROM dual";
}

sub genid {
    my $gen = shift;
    my $inc = shift || 0;

    return sqlff "SELECT gen_id($gen, $inc) FROM dual";
}

sub get_class_link($) {
    my $paralel =
        sqlff 'select paralel from sys_matrix where class = '
      . (shift)
      . " and sys_matrix.view_class = 7
and exists ( select 1 from get_node_saldo
    (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)";

    my $link = 0;
    if    ( $paralel > 4 and $paralel < 10 ) { $link = 1 }
    elsif ( $paralel > 9 and $paralel < 13 ) { $link = 2 }

    return $link;
}

sub str2unicode {
    my $str = shift;
    my $converter = Text::Iconv->new( 'windows-1251', 'utf-8' );
    return $converter->convert($str);

    return $str;
}

sub utf8_to_win {
    my $str = shift;
    my $converter = Text::Iconv->new( "utf-8", "windows-1251" );
    return $converter->convert($str);

}

sub utf8_to_koi8r {
    my $str = shift;
    my $converter = Text::Iconv->new( "utf-8", "KOI8-R" );
    return $converter->convert($str);
}

sub win_to_koi8r {
    my $str = shift;
    my $converter = Text::Iconv->new( "windows-1251", "KOI8-R" );
    return $converter->convert($str);
}

sub koi8r_to_win {
    my $str = shift;
    my $converter = Text::Iconv->new( "KOI8-R", "windows-1251" );
    return $converter->convert($str);
}

sub get_new_message_count() {
    return sqlffcms( "SELECT count(1) FROM msg_send WHERE u_id = " 
          . $guid
          . " AND cmd_s = 0" )
      || 0;
}

sub auto_check_msg() {
    my $auto_check_msg = cookie("SP_ACheckMsg");
    if ( defined $auto_check_msg ) {
        if (   $auto_check_msg !~ m/^\d+$/
            or $auto_check_msg < 2
            or $auto_check_msg > 15 )
        {
            return (0);
            setcookie("SP_ACheckMsg");
        }

        return ( $auto_check_msg ? $auto_check_msg : 0 );
    }

    $auto_check_msg =
      sqlff("select f_int from sp_user_settings where uid = $guid and id=1");
    setcookie( 'SP_ACheckMsg', $auto_check_msg );

    return ( $auto_check_msg ? $auto_check_msg : 0 );
}

sub log_user_sesion {
    my ( $type, $container, $container2 ) = @_;
    $type = $type < 1 ? 1 : $type;
    my $ip = $ENV{'REMOTE_ADDR'};
    $ip =~ s/'//g;
    my $ip_for = substr( $ENV{'HTTP_X_FORWARDED_FOR'} || '', 0, 40 );
    $ip_for =~ s/'//g;
    $ip_for =
      ( defined($ip_for) and length($ip_for) > 0 ) ? qq['$ip_for'] : 'NULL';
    my $agent = substr( $ENV{'HTTP_USER_AGENT'}, 0, 127 );
    $agent =~ s/'//g;

    unless ( defined($container) ) {
        $container = 'NULL';
    }
    my ( $SQL_id_credit, $SQL_id_value, $flag_insert_session );
    $SQL_id_value = $SQL_id_credit = '';
    $flag_insert_session = 1;

    if ( $type >= 6 && $type <= 11 ) {
        $SQL_id_credit =
          sqlffcms('SELECT gen_id(gen_logs_session_id, 1) FROM dual');
        $SQL_id_value = ",ids";

        log_user_matrix_insert( $SQL_id_credit, 1, $type, $container,
            $container2 );

        $SQL_id_credit = ",'" . $SQL_id_credit . "'";

        $guid = $ggid = $container = 'NULL';
    }
    elsif ( $type >= 2 && $type <= 4 ) {
        $flag_insert_session = 0;
        sqlcms(
            "UPDATE logs_session SET s_exit = '$type', date_exit = 'NOW'
    WHERE s = 1 AND ip = '$ip' AND sid = $container AND agent = '$agent'"
        );
    }
    elsif ( $type == 5 ) {
        $flag_insert_session = 0;
        sqlcms(
            "UPDATE logs_session SET s_exit = '$type', date_exit = 'NOW'
    WHERE s = 1 AND sid = "
              . $container2->[0]
              . " AND ip = '"
              . $container2->[1] . "'"
        );
    }
    elsif ( $type >= 12 && $type <= 19 ) {
        $flag_insert_session = 0;
        sqlcms(
            "UPDATE logs_session SET s = '$type', date_exit = 'NOW'
    WHERE s = 1 AND ip = '$ip' AND sid = $container AND agent = '$agent'"
        );
    }

    if ($flag_insert_session) {
        sqlcms(
"INSERT INTO logs_session (s,ip,ip_for,agent,gid,uid,date_s,sid $SQL_id_value)
    VALUES ($type,'$ip',$ip_for,'$agent',$ggid,$guid,'NOW',$container $SQL_id_credit)"
        );
    }
}

sub log_user_matrix_insert($$$$$) {
    my $mid        = shift;
    my $type_t     = shift;
    my $stat       = shift;
    my $container  = shift;
    my $container2 = shift;
    my $q          = $gdbcms->prepare(
qq{INSERT INTO logs_matrix (mid,type_t,stat,container,container2) VALUES (?, ?, ?, ?, ?)}
    ) or db_error();
    $q->execute( $mid, $type_t, $stat, $container, $container2 ) or db_error();
}

sub dmpsql {
    my $sql = shift || error "empty query";
    error "dmpsql/dmpsqlcms   ,   select"
      unless $sql =~ m/^\s*select/i;

    my @data;
    my $result = "</pre><table border=1 cellspacing=0 cellpadding=2><tr>";
    my $q;
    my @fields;

    $q      = sqlp($sql);
    @fields = @{ $q->{NAME} };
    foreach (@fields) { $result .= "<th bgcolor=#eeeeee>$_</th>"; }
    while ( @data = $q->fetchrow_array() ) {
        $result .= "</tr><tr>";
        foreach (@data) {
            s/\s/&nbsp;/go;
            unless ( defined $_ ) {
                $_ = '<span class=copy id="error">Nul</span>';
            }
            $result .= "<td bgcolor=\"#ffffff\">$_</td>";
        }
    }
    $result .= "</tr></table>";
    $q->finish;
    error(
        qq[<a href="?act=sql_execute_form"></a><br><br>$sql<br><br>$result]
    );
}

sub sqlacms {
    my $a_ref = shift;
    my $sql   = shift;
    my $attr  = shift;
    my (@a);
    __sql_prolog() if $DEBUG;
    my $q = $gdbcms->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute(@_) or report_sql_error($sql);
    while ( @a = $q->fetchrow_array ) { push @{$a_ref}, [@a]; }
    $q->finish;
    __sql_epilog_cms( \$sql ) if $DEBUG;
}

sub dmpsqlcms {
    my $sql = shift || error "empty query";
    error "dmpsql/dmpsqlcms   ,   select"
      unless $sql =~ m/^\s*select/i;

    my @data;
    my $result = "</pre><table border=1 cellspacing=0 cellpadding=2><tr>";
    my $q;
    my @fields;

    $q      = sqlpcms($sql);
    @fields = @{ $q->{NAME} };
    foreach (@fields) { $result .= "<th bgcolor=#eeeeee>$_</th>"; }
    while ( @data = $q->fetchrow_array() ) {
        $result .= "</tr><tr>";
        foreach (@data) {
            unless ( defined $_ ) {
                $_ = '<span class=copy id="error">NULL</span>';
            }
            s/\s/&nbsp;/go;
            $result .= "<td bgcolor=\"#ffffff\">$_</td>";
        }
    }
    $q->finish;
    $result .= "</tr></table>";
    error(
        qq[<a href="?act=sql_execute_form"></a><br><br>$sql<br><br>$result]
    );
}

sub read_acl() {
    %ACL = ();
    sqlh( \%ACL,
        "select gid,1 from sp_users_acl where sp_users_acl.uid = $guid" );
}

sub year_academic() {
    my ( $y, $tm_month, @year );
    $gdate =~ /^\d+\.(\d+)\.(\d+)/;
    ( $tm_month, $y ) = ( $1, $2 );

    if ( $tm_month > 8 ) { $year[0] = $y;
        $year[1] = $y + 1;
    }
    else {
        $year[0] = $y - 1;
        $year[1] = $y;
    }
    return @year;
}

sub get_year_start_end {
    my $uid = shift || undef;
    my $link = get_class_link( get_pupil_class( 0, $uid ) );
    return sqlf
"select time_start, time_end from sp_periods where link = $link and id = 0";
}

sub escape_tag($) {
    my $s = shift;
    !defined $$s and return $$s;

    $$s =~ s/&/&amp;/go;
    $$s =~ s/</&lt;/go;
    $$s =~ s/>/&gt;/go;
    $$s =~ s/'/&ldquo;/go;
    $$s =~ s/"/&quot;/go;

    return $$s;
}

our (%HTMLFilterSet);

sub strip_tag {
    my $s = shift;
    !defined $$s and return $$s;

    my $type = shift || '';

    unless ( $HTMLFilterSet{'clear'} ) {
        $HTMLFilterSet{'clear'} = HTML::TagFilter->new(
            allow               => {},
            log_rejects         => 0,
            strip_comments      => 1,
            skip_xss_protection => 0,
            skip_entification   => 1,
        );
    }
    unless ( $HTMLFilterSet{'nohtml'} ) {
        $HTMLFilterSet{'nohtml'} = HTML::TagFilter->new(
            allow => {
                span => {},
                b    => {},
                i    => {},
                s    => {},
            },
            log_rejects         => 0,
            strip_comments      => 1,
            skip_xss_protection => 0,
            skip_entification   => 1,
        );
    }
    unless ( $HTMLFilterSet{'html'} ) {
        $HTMLFilterSet{'html'} = HTML::TagFilter->new(
            allow => {
                any => {
                    class  => ['any'],
                    style  => ['any'],
                    width  => ['any'],
                    height => ['any'],
                    border => [ 0 .. 20 ],
                    title  => ['any'],
                    align  => [qw(left center right justify absmiddle)],
                    valign =>
                      [qw(top text-top super bottom text-bottom middle sub)],
                },
                div        => {},
                span       => {},
                p          => {},
                h1         => {},
                h2         => {},
                h3         => {},
                br         => {},
                b          => {},
                strong     => {},
                i          => {},
                em         => {},
                s          => {},
                u          => {},
                strike     => {},
                sub        => {},
                sup        => {},
                blockquote => {},
                font       => {
                    face  => ['any'],
                    size  => [ -7 .. 7 ],
                    color => ['any'],
                },
                table => {
                    cellspacing => [ 0 .. 25 ],
                    cellpadding => [ 0 .. 50 ],
                    bgcolor     => ['any'],
                    background  => ['any'],
                },
                tr => { bgcolor => ['any'], },
                td => {
                    colspan => [ 0 .. 100 ],
                    rowspan => [ 0 .. 100 ],
                    bgcolor => ['any'],
                    nowrap  => [],
                },
                th => {
                    colspan => [ 0 .. 100 ],
                    rowspan => [ 0 .. 100 ],
                    bgcolor => ['any'],
                    nowrap  => [],
                },
                a => {
                    href   => ['any'],
                    target => ['any'],
                },
                img => {
                    src    => ['any'],
                    hspace => [ 0 .. 50 ],
                    vspace => [ 0 .. 50 ],
                    alt    => ['any'],
                },
                ul => { type => [qw(disc circle square)], },
                ol => {
                    start => ['any'],
                    type  => [qw(disc circle square)],
                },
                li => {
                    type  => [qw(1 a A i I)],
                    value => ['any'],
                },
                hr => { size => [ 0 .. 10 ], },
            },
            log_rejects              => 0,
            strip_comments           => 1,
            skip_xss_protection      => 0,
            skip_entification        => 1,
            skip_mailto_entification => 1,
        );
    }

    if ( $type eq 'nohtml' ) {
        $HTMLFilterSet{'nohtml'}->parse($$s);
        $$s = $HTMLFilterSet{'nohtml'}->output;
    }
    elsif ( $type eq 'clear' ) {
        $HTMLFilterSet{'clear'}->parse($$s);
        $$s = $HTMLFilterSet{'clear'}->output;
    }
    else {
        $HTMLFilterSet{'html'}->parse($$s);
        $$s = $HTMLFilterSet{'html'}->output;
    }

    $$s =~ s/\s+/ /go;
    return $$s;
}

sub declension {
    my $int         = shift;
    my $expressions = shift;

    my $count = $int % 100;
    my $result;
    if ( $count >= 5 && $count <= 20 ) {
        $result = $$expressions[2];
    }
    else {
        $count = $count % 10;
        if ( $count == 1 ) { $result = $$expressions[0]; }
        elsif ( $count >= 2 && $count <= 4 ) { $result = $$expressions[1]; }
        else                                 { $result = $$expressions[2]; }
    }
    return $result;
}

our %gid_decl = (
    0 => [ '', '', '' ],
    1 => [
        '  ',
        '  ',
        '  '
    ],
    2 => [ '',    '',     '' ],
    4 => [ '',     '',     '' ],
    6 => [ 'web-', 'web-', 'web-' ],
);

our $aboutouStartDate_cache;

sub aboutouStartDate {
    unless ( defined $aboutouStartDate_cache ) {
        $aboutouStartDate_cache = sqlff(

"select min(entry_date) from sys_entry where sys_entry.doc_class = 5 and
			exists(select 1 from doc_deduction_order where doc_no = sys_entry.doc and finish_flag = 1)",

            { ib_timestampformat => '%d.%m.%Y' }

        );
    }
    return $aboutouStartDate_cache;

}

sub msg_send {

    my $send    = shift;
    my $subject = shift;
    my $message = shift;
    my $ot      = shift;
    $ot ||= -1;
    my ( $error, $new_id_credit );
    if ( length($subject) < 1 ) { $error .= "s"; }
    if ( length($message) < 3 ) { $error .= "m"; }

    if ( length($send) < 1 ) { $error .= "u"; }

    my $date_send = $gdate;

    if ( $error eq "" ) {
        $subject =~ s/&/&amp;/g;
        $subject =~ s/</&lt;/g;
        $subject =~ s/>/&gt;/g;
        $subject =~ s/'/&ldquo;/g;
        $subject =~ s/"/&quot;/g;
        $subject = substr( $subject, 0, 127 );
        $message =~ s/&/&amp;/g;
        $message =~ s/</&lt;/g;
        $message =~ s/>/&gt;/g;
        $message =~ s/'/&ldquo;/g;
        $message =~ s/"/&quot;/g;

        my ( @black_list, @result );
        if ( $ot > 0 ) {
            my $q = sqlpcms(
                "SELECT uid FROM msg_address_book WHERE fav = $ot AND s = -1");
            while ( @result = $q->fetchrow_array() ) {
                push @black_list, @result;
            }
        }

        $new_id_credit =
          sqlffcms('SELECT gen_id(gen_msg_message_text_id, 1) FROM dual');

        my $i = 0;
        for my $send_st ( split /,/, $send ) {
            sec_gt0($send_st);
            next if grep( /^$send_st$/, @black_list );
            if ( $send_st ne "" ) {
                sqlcms(
"INSERT INTO msg_send (msg_id,u_id) VALUES ($new_id_credit,$send_st)"
                );
                $i++;
            }
        }

        if ( $i >= 1 ) {
            my $q = $gdbcms->prepare(
qq{INSERT INTO msg_message_text (id,author_id,date_sent,cmd_i,subject,message_text) VALUES (?, ?, ?, ?, ?, ?)}
            ) or db_error();
            $q->execute( $new_id_credit, $ot, 'NOW', 3, $subject, $message )
              or db_error();
        }

        my $NOW = todate(time);
        my @q =
          sqlfcms("SELECT c FROM msg_stat WHERE date_m='$NOW' AND type_g = -1");

        if ( $q[0] ) {
            sqlcms(
                "UPDATE msg_stat SET c=c+1 WHERE date_m='$NOW' AND type_g = -1"
            );
        }
        else {
            sqlcms(
                "INSERT INTO msg_stat (c,type_g,date_m) VALUES (1,-1,'$NOW')");
        }
        return 1;
    }
    else {
        return $error;
    }
}

sub pub_send(@) {
    my (
        $selGrp,  $selParalel, $selClass, $date_begin, $date_end,
        $subject, $message,    $from,     $id,         $edit_noRead
    ) = @_;
    $from ||= -1;

    my $edit = ( defined $id && $id == 1 ) ? 1 : 0;

    my ( $error, $new_id_credit, %pup_hash, $author_id, $author_edit );
    $error = '';

    if ($edit) {
        sec_gteq0($id);
        $author_id =
          sqlffcms( "SELECT author_id FROM msg_public_text WHERE "
              . ( $from > 1 ? "author_id = $from AND " : "" )
              . "id = $id" );
        $author_id < 1 and redir('announcement&mesg=ban');
    }

    sec_date($date_begin);
    sec_date($date_end);

    my ( $d,  $m,  $y )  = split( /\./, $date_begin );
    my ( $d2, $m2, $y2 ) = split( /\./, $date_end );

    if ( $y2 . $m2 . $d2 < $y . $m . $d ) {
        stop("       "
        );
    }

    my $t_date =
      (   ( (localtime)[5] + 1900 )
        . ( length( (localtime)[4] + 1 ) == 1 ? "0" : "" )
          . (localtime)[4] + 1
          . ( length( (localtime)[3] ) == 1 ? "0" : "" )
          . (localtime)[3] );
    if ( $y2 . $m2 . $d2 < $t_date or $y . $m . $d < $t_date ) {
        stop(
"        "
        );
    }

    if ( $from > 0 ) {
        my $max_time_end = sqlff(
            "select max(time_end) from sp_periods where id = "
              . (
                sqlff(
                    "select F_INT from SP_SETTINGS where NAME = 'periods_mode'")
                ? '4'
                : '7'
              )
        );

        my ( undef, undef, undef, $d, $m, $y, undef, undef, undef ) =
          localtime $max_time_end;
        $y += 1900;
        $m++;
        $max_time_end = sprintf "%04d.%02d.%02d", $y, $m, $d;

        if ( $y2 . $m2 . $d2 gt $max_time_end ) {
            stop(
"          "
            );
        }
    }

    $date_end = $date_end . " 23:59:59";

    if ( $ggid == 4 ) { $selGrp = $selParalel = '';
    }

    if ( length($subject) < 1 )                            { $error .= "s"; }
    if ( length($message) < 3 )                            { $error .= "m"; }
    if ( length( $selGrp . $selParalel . $selClass ) < 1 ) { $error .= "u"; }

    my ( $sec, $min, $hour, $mday, $mon, $year, $wday, undef, undef ) =
      localtime;
    my $date_send = $gdate;

    if ( $error eq "" ) {
        if ( $from > 0 ) {
            $subject =~ s/&/&amp;/g;
            $subject =~ s/</&lt;/g;
            $subject =~ s/>/&gt;/g;
            $subject =~ s/'/&ldquo;/g;
            $subject =~ s/"/&quot;/g;
            $subject = substr( $subject, 0, 127 );
            strip_tag( \$message, 'html' );
        }

        $new_id_credit =
            $edit
          ? $id
          : sqlffcms('SELECT gen_id(gen_msg_public_text_id, 1) FROM dual');

        $edit
          and sqlpcms( "DELETE FROM msg_public_send WHERE pub_id = " . $id );

        my $pupels = 1;
        my $selGrp_st;

        for $selGrp_st ( split /,/, $selGrp ) {
            if ( $selGrp_st ne "" ) {
                sqlcms(
                    "INSERT INTO msg_public_send (pub_id,type_g,gid)
          VALUES ($new_id_credit,1,$selGrp_st)"
                );
            }
            if ( $selGrp_st == 4 ) {
                $pupels = 0;
            };
        }

        if ( $pupels == 1 ) {
            for my $selParalel_st ( split /,/, $selParalel ) {
                if ( $selParalel_st ne "" ) {
                    sqlcms(
                        "INSERT INTO msg_public_send (pub_id,type_g,gid)
            VALUES ($new_id_credit,2,$selParalel_st)"
                    );
                }
                my $q = sqlp(
"select cast(class AS integer) from sys_matrix where view_class = 7 and paralel = $selParalel_st
          and exists (select 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)"
                );
                while ( my @result = $q->fetchrow_array() ) {
                    $pup_hash{ $result[0] } = $selParalel_st;
                }
            }

            for my $selClass_st ( split /,/, $selClass ) {
                if ( $selClass_st ne "" and $pup_hash{$selClass_st} < 1 ) {
                    sqlcms(
                        "INSERT INTO msg_public_send (pub_id,type_g,gid)
            VALUES ($new_id_credit,3,$selClass_st)"
                    );
                }
            }
        }

        $edit and sqlpcms( "DELETE FROM msg_public_text WHERE id = " . $id );

        if ( $edit and $from != $author_id ) {
            my $q = $gdbcms->prepare(
qq[INSERT INTO msg_public_text (id,author_id,date_begin,date_end,stat,subject,message_text,author_edit) VALUES (?, ?, ?, ?, ?, ?, ?, ?)]
            ) or db_error();
            $q->execute( $new_id_credit, $author_id, $date_begin, $date_end, 0,
                $subject, $message, $guid )
              or db_error();
        }
        else {
            my $q = $gdbcms->prepare(
qq[INSERT INTO msg_public_text (id,author_id,date_begin,date_end,stat,subject,message_text) VALUES (?, ?, ?, ?, ?, ?, ?)]
            ) or db_error();
            $q->execute( $new_id_credit, $from, $date_begin, $date_end, 0,
                $subject, $message )
              or db_error();
        }

        $edit_noRead
          and sqlpcms( "DELETE FROM msg_public_read WHERE p_id = " . $id );

        return 1;
    }
    else {
        return $error;
    }

}

sub redir {
    my $redir = shift;
    my $files = shift || $ENV{SCRIPT_NAME};
    print $HTTP_HEADER_ADD;
    exit print redirect( $files . '?act=' . $redir );
}

sub tab_links {
    my ( $top, @values, $tablinck, $txt, $tmp );
    my $tab = param("tab") || 0;
    @values = @_;

    $top = '';
    for ( my $i = 1 ; $values[$i] ; $i++ ) {
        $tablinck = $values[$i][1];

        $tablinck =
          ( $tablinck =~ /^\&/ )
          ? "?act=" . param('act') . $tablinck
          : "?act=" . $tablinck;
        $txt = qq[<a href="$tablinck">$values[$i][0]</a>];

        $tablinck =~ /tab=(\w+)/io;
        if ( ( $tab eq "" && $i == 1 ) || $1 eq $tab ) {
            $tmp = "a";
            $txt = qq[$values[$i][0]];
        }
        else { $tmp = ""; }

        $top .= tpl_str(
            "./tpl/tabcontrol" . $tmp . ".html",
            { tab => $txt, display => '' }
        );
    }

    if ( $values[0][3] ) {
        $values[0][3] =
qq[<tr id=BottonPanel><td class="BottonPanel">$values[0][3]</td></tr>];
    }
    my %replace = (
        'body' => $values[0][0], 'top' => $top,
        'BottonPanel' => ( defined $values[0][3] ? $values[0][3] : '' )
    );
    return tpl_str( "./tpl/tab_desktop.html", \%replace );
}

sub tab_div {
    my (
        $body,    $top, @values, $tabdiv,   $tablinck,
        @display, $i,   $j,      @key_link, $key_activ
    );
    my $tab = param("tab") || 0;

    my $pad = 0;
    if ( $_[-1] =~ /^\d+$/ ) {
        $pad = $_[-1];
        delete $_[-1];
    }

    @values      = @_;
    $tab         = ( $tab =~ /^\d+$/io ) ? $tab : -1;
    $key_link[0] = 1;
    $key_link[1] = 0;
    $key_activ   = 0;

    $body = $top = '';
    for ( $i = $j = 0 ; $values[$i] ; $i++ ) {
        if (   ( $i == 0 and $tab == -1 )
            || ( $i == $tab and !$values[$i][2] )
            || ( !$values[$i][2] and $key_activ ) )
        {
            $display[0] = " id='tabc_$i' style='display:none;'";
            $display[1] = " id='taba_$i'";
            $display[2] = '';
        }
        else {
            $display[0] = " id='tabc_$i'";
            $display[1] = " id='taba_$i' style='display:none;'";
            $display[2] = "style='display:none;'";
            $key_activ  = 1;
        }

        $tabdiv = qq[<span onClick="tabcontrol('_$i')">$values[$i][0]</span>];

        if ( defined $values[$i][2] && $values[$i][2] eq 1 ) {
            $tablinck =
              ( $values[$i][1] =~ /^\&/ )
              ? "?act=" . param('act') . $values[$i][1]
              : "?act=" . $values[$i][1];
            $top .= tpl_str(
                './tpl/tabcontrol.html',
                {
                    tab     => qq[<a href='$tablinck'>$values[$i][0]</a>],
                    display => ''
                }
            );
            $j--;
        }
        else {
            $top .=
              tpl_str( './tpl/tabcontrol.html',
                { tab => $tabdiv, display => $display[0] } );
            $top .=
              tpl_str( './tpl/tabcontrola.html',
                { tab => $tabdiv, display => $display[1] } );
            $body .= qq[<div id='tab_$i'$display[2]>$values[$i][1]</div>];
        }
    }

    $body .=
        qq[<div id="tabcontrol_keys_arr" style='display:none;'>]
      . ( $i + $j )
      . q[</div>];

    if ( $values[0][3] ) {
        $values[0][3] =
qq[<tr id=BottonPanel><td class="BottonPanel">$values[0][3]</td></tr>];
    }
    return tpl_str(
        './tpl/tab_desktop.html',
        {
              'body' => $pad
            ? qq[<div style="padding:\Q$pad\Epx">$body</div>]
            : $body,
            'top'         => $top,
            'BottonPanel' => ( defined $values[0][3] ? $values[0][3] : '' )
        }
    );
}

sub avg {
    my $array     = shift || return 0;
    my $precision = shift || '0';
    return (0) unless scalar( @{$array} );
    my $sum = 0;
    for ( @{$array} ) { s/,/./; $sum += $_; }
    $sum /= scalar( @{$array} );
    $sum = sprintf "%.${precision}f", $sum;
    $sum =~ s/,/./;
    return $sum;
}

sub sum {
    my $array = shift || return 0;
    return (0) unless scalar( @{$array} );
    my $sum = 0;
    for ( @{$array} ) { $sum += $_; }
    return $sum;
}

sub cleanup_tmp($) {
    my $folder    = shift;
    my $timestamp = time;
    opendir D, $gconf{sppath} . "/tmp/$folder/";
    my @tmp_files = readdir(D);
    closedir D;
    for (@tmp_files) {
        if (/(\d+)/) {
            if ( $timestamp - $1 > $gconf{'session_idle_max'} ) {
                unlink $gconf{sppath} . "/tmp/$folder/" . $_;
            }
        }
    }
}

sub move_date_to_time_machine($) {
    my $date = shift;
    my @y    = year_academic();
    $date =~ m/^(\d\d)\.(\d\d)/;
    my ( $d, $m ) = ( $1, $2 );
    $gdate =~ m/(\d\d\d\d)$/;
    my $yyyy = $1 - 1;
    return "$d.$m.$yyyy";
}

sub security_alert {
    my $param;
    my $problem     = shift;
    my $description = shift;
    for ( param() ) {
        if ( $problem eq param $_ ) { $param = $_; last; }
    }

    unless ( defined $param ) {
        $param = 'ALERT';
    }

    my $school = MOUName('short');
    my $req    = $ENV{'QUERY_STRING'};
    my $ip     = $ENV{'REMOTE_ADDR'};
    $ip .= ' / ' . $ENV{'HTTP_X_FORWARDED_FOR'} if $ENV{'HTTP_X_FORWARDED_FOR'};
    my $agent = $ENV{'HTTP_USER_AGENT'};
    my $sid   = cookie("sp_sid");
    my ( $uid, $log, $gid_name );
    my $fio = '';
    if ( $sid =~ m/^\d+$/ ) {
        $uid = sqlff(
            "select sp_users.uid from sp_users, sp_users_logged
where sp_users_logged.sid = '$sid'
and sp_users.uid = sp_users_logged.uid"
        ) || '';
        $log = sqlff(
            "select sp_users.log from sp_users, sp_users_logged
where sp_users_logged.sid = '$sid'
and sp_users.uid = sp_users_logged.uid"
        ) || '';
        if ( $uid =~ m/^\d+$/ ) {
            $fio = sqlff(
"select trim(last_name) || ' ' || trim(first_name) || ' ' || trim(middle_name)
from human where human_id = $uid"
            );
        }
        if ( defined $ggid ) {
            $gid_name = sqlff(qq[select name from sp_gid_ref where gid=$ggid]);
        }

    }

    my $fake_from = $gconf{db_path};
    $fake_from =~ s/^.+XXI-.-//i;
    $fake_from =~ s/\.gdb$//i;
    $fake_from =~ s/^0+//;
    $fake_from = 'SP at school #' . $fake_from;

    my ( $sec, $min, $hour, $mday, $mon, $year, $wday, undef, undef ) =
      localtime;
    $year += 1900;
    my $time =
        timelocal(localtime)
      . " | $mday $mnths[$mon] $year, $wdays[$wday-1], "
      . sprintf( "%02d:%02d", $hour, $min );

    my $periods_mode_str =
      ( sqlff(q[select f_int from sp_settings where name='periods_mode']) )
      ? ''
      : '';

    my $client;
    unless ($DEBUG) {
        $client = IO::Socket::INET->new("$gconf{'smtp'}:25");
    }

    my $stacktrace =
      "\n" . Carp::longmess('<pre>   (-):<br>');
    $stacktrace =~ s/\t/  /g;
    $stacktrace =~ s|/var/www/cgi-bin/sp/||g;
    $stacktrace =~
      s|main::(\w+).+at( .+\..+)line(.+)|^ :$2\t:$3\t: $1|g;

    my $report_user = " ";
    if (   defined $log
        or defined $uid
        or defined $gid_name )
    {
        $report_user = ": $log | UID: $uid | : $gid_name";
    }

    if ($fio) {
        $report_user .= "\n:      $fio";
    }

    my $report_HTTP_REFERER =
      $ENV{'HTTP_REFERER'} ? "\nReferer:  $ENV{'HTTP_REFERER'}" : '';

    my $hostname = $ENV{HTTP_HOST};

    my $description_str = $description ? "\n: $description" : '';

    my $report = ":      $school
:     $report_user
IP:       $ip | http://nic.ru/whois/?query=$ip
HOST:     $hostname
:  $agent
:    $time | $periods_mode_str
:   $ENV{'SCRIPT_NAME'} v$version
Light:    $gconf{'Light'}
:   $param=$problem $description_str
:    $ENV{'REQUEST_METHOD'}
:   $ENV{'QUERY_STRING'}$report_HTTP_REFERER";

    my @tmp_params = param();
    my %tmp_hash;
    $tmp_hash{$_} = param($_) for (@tmp_params);

    @ARGV = ();

    $report .= ("\n\n : ") . Dumper( \%tmp_hash );

    my $mail;
    unless ($client) {
        $mail =
qq[<h2 id=error>SMTP-   &mdash;    </h2>
     (   )   .          .<br><br>
<textarea id="report" style="width: 100%; font: 8pt monospace; margin-bottom: 6px" rows=16 readonly wrap=off>$report</textarea><button type=button onclick="document.getElementById('report').select()";> </button>];
    }
    else {
        my $sender = new Mail::Sender {
            smtp      => $gconf{'smtp'},
            from      => 'xxibasequery@' . $ENV{'SERVER_NAME'},
            fake_from => $fake_from
              . ' <xxibasequery@'
              . $ENV{'SERVER_NAME'} . '>',
            priority => 1,
            charset  => 'Windows-1251'
        };

        my $developer;

        if ( $ENV{'SCRIPT_NAME'} =~ m/cms\.pl/ ) {
            $developer = 'ant@cir.tgl.ru';
        }
        else { $developer = 'djandrey@cir.tgl.ru'; }

        $sender->MailMsg(
            {
                to      => $developer,
                subject => 'SP Error Report',
                msg     => $report . $stacktrace
            }
        );
        $mail =
'<h2>      .</h2>';
    }

    error(
qq[  ,        
    .
      .
 <a href="javascript:history.go(-1);"></a>   ,     .
 <a href="$gconf{'sp'}?act=logout"></a>   .<br><br>

<span class="small" style="font-weight: normal;">
       ,      ,     ,
 <a class="small" href="http://spcms.ru/contact" target="_blank">  </a>.
       ,
      
  .<br><br>
</span>
$mail
]
    );
}

sub report_sql_error {
    my $sql = shift;
    my $err = $DBI::errstr;

    unless ($DEBUG) {
        my ( $ouname, $ounum ) = MOUName();
        my $school = "$ouname  $ounum";
        $school =~ s/\s+/ /g;
        $school = trim($school);
        my $req = $ENV{'QUERY_STRING'};
        my $ip  = $ENV{'REMOTE_ADDR'};
        $ip .= ' / ' . $ENV{'HTTP_X_FORWARDED_FOR'}
          if $ENV{'HTTP_X_FORWARDED_FOR'};
        my $agent = $ENV{'HTTP_USER_AGENT'};
        my $sid   = cookie("sp_sid");
        my ( $uid, $log, $gid_name );
        my $fio = '';

        if ( $sid =~ m/^\d+$/ ) {
            $uid = sqlff(
                "select sp_users.uid from sp_users, sp_users_logged
			where sp_users_logged.sid = '$sid'
			and sp_users.uid = sp_users_logged.uid"
            ) || '';
            $log = sqlff(
                "select sp_users.log from sp_users, sp_users_logged
			where sp_users_logged.sid = '$sid'
			and sp_users.uid = sp_users_logged.uid"
            ) || '';
            if ( $uid =~ m/^\d+$/ ) {
                $fio = sqlff(
"select trim(last_name) || ' ' || trim(first_name) || ' ' || trim(middle_name)
				from human where human_id = $uid"
                );
            }
            if ( $ggid =~ m/^\d+$/ ) {
                $gid_name =
                  sqlff(qq[select name from sp_gid_ref where gid=$ggid]);
            }
        }

        my $fake_from = $gconf{db_path};
        $fake_from =~ s/^.+XXI-.-//i;
        $fake_from =~ s/\.gdb$//i;
        $fake_from =~ s/^0+//;
        $fake_from = 'SP at school #' . $fake_from;

        my ( $sec, $min, $hour, $mday, $mon, $year, $wday, undef, undef ) =
          localtime;
        $year += 1900;
        my $time =
            timelocal(localtime)
          . " - $mday $mnths[$mon] $year, $wdays[$wday-1], "
          . sprintf( "%02d:%02d", $hour, $min );

        my $periods_mode_str =
          ( sqlff(q[select f_int from sp_settings where name='periods_mode']) )
          ? ''
          : '';

        my $report = "SQL\n\n$sql\n
Error:\n$err\n
client:  $school
user:    $log / $uid / $gid_name
name:    $fio
ip:      $ip http://www.nic.ru/whois/?query=$ip
ua:      $agent
time:    $time
periods: $periods_mode_str
script:  $version $ENV{'SCRIPT_NAME'}
light:   $gconf{'Light'}
query:   $ENV{'REQUEST_METHOD'} / $ENV{'QUERY_STRING'}";

        my @tmp_params = param();
        my %tmp_hash;
        $tmp_hash{$_} = param($_) for (@tmp_params);
        $report .= ( "\n\nparams: " . Dumper( \%tmp_hash ) );

        my $stacktrace =
          "\n" . Carp::longmess('   (-):<br>');
        $stacktrace =~ s/\t/  /g;
        $stacktrace =~ s|/var/www/cgi-bin/sp/||g;
        $stacktrace =~
s|main::(\w+).+at( .+\..+)line(.+)|^ :$2\t:$3\t: $1|g;

        my $client = IO::Socket::INET->new("127.0.0.1:25");

        if ($client) {

            my $sender = new Mail::Sender {
                smtp      => $gconf{'smtp'},
                from      => 'xxibasequery@' . $ENV{'SERVER_NAME'},
                fake_from => $fake_from
                  . ' <xxibasequery@'
                  . $ENV{'SERVER_NAME'} . '>',
                priority => 1,
                charset  => 'Windows-1251'
            };

            my $developer;
            if ( $ENV{'SCRIPT_NAME'} =~ m/cms\.pl/ ) {
                $developer = 'ant@cir.tgl.ru';
            }
            else { $developer = 'djandrey@cir.tgl.ru'; }

            $sender->MailMsg(
                {
                    to      => $developer,
                    subject => 'SP Error Report (SQL)',
                    msg     => $report . $stacktrace
                }
            );

        }

        stop("      .");
    }
    else {
        error(
qq[<link type="text/css" rel="stylesheet" href="/sp/highlight/magula.css">
<script type="text/javascript" src="/sp/highlight/highlight.pack.js"></script>
<script type="text/javascript">hljs.initHighlightingOnLoad();</script>
:<br><pre id="sql_query"><code>$sql</code></pre>:<br><pre>$err</pre>
]
        );
    }
}

sub sec_gt0 {
    my $test     = shift;
    my $empty_ok = shift;

    if ( defined $empty_ok ) { return unless $test; }

    if ( $test !~ m/^\d+$/ or $test == 0 or $test > 4294967295 ) {
        security_alert( $test, 'not number or > 4294967295' );
    }

    return $test;
}

sub sec_gteq0 {
    my $test     = shift;
    my $empty_ok = shift;

    if ( defined $empty_ok ) { return unless $test; }

    unless ( defined $test ) {
        security_alert('undefined value passed to sec_gteq0');
    }

    if ( $test !~ m/^\d+$/ or $test < 0 or $test > 4294967295 ) {
        security_alert( $test, 'not number | < 0 | > 4294967295' );
    }

    return $test;
}

sub sec_range($$$) {
    my ( $test, $min, $max ) = ( shift, shift, shift );

    unless ( defined $test ) { security_alert("undefined value passed") }

    if ( $test !~ m/^\d+$/ or $test < $min or $test > $max ) {
        security_alert( $test, "not number | < $min | > $max" );
    }

    return $test;
}

sub sec_date($) {
    my $test = shift;

    if ( $test !~ m/^[0-3]?[0-9]\.[0-9]?[0-9]\.[0-9][0-9][0-9][0-9]$/ ) {
        escape_tag( \$test );
        stop(
qq[   : ..   (,&nbsp;$gdate  17.1.2012 (   )).<br><br> : &#147;$test&#148;]
        );
    }

    $test =~ m/^(.+)\.(.+)\.(.+)/;

    if ( $1 < 1 or $1 > 31 ) {
        my $t1 = $1;
        escape_tag( \$t1 );
        escape_tag( \$test );
        stop(
qq[       1&mdash;31.<br><br>  : &#147;$t1&#148;   $test]
        );
    }

    if ( $2 < 1 or $2 > 12 ) {
        my $t1 = $2;
        escape_tag( \$t1 );
        escape_tag( \$test );
        stop(
qq[       1&mdash;12.<br><br>  : &#147;$t1&#148;   $test]
        );
    }

    if ( $1 > DaysInMonth( $2, $3 ) ) {
        my $t1 = $2;
        escape_tag( \$t1 );
        escape_tag( \$test );
        stop(
            qq[   $2    $1. : &#147;$test&#148;]);
    }

    return $test;
}

sub sec_time($) {

    my $t = trim(shift);

    $t =~ s/[. ]/:/g;

    if ( $t =~ m/^(2[0-3]|[0-1]?[0-9])\:[0-5]?[0-9]$/ ) {
        $t .= ':00';
    }

    if ( $t !~ m/^(2[0-3]|[0-1]?[0-9])\:[0-5]?[0-9]\:[0-5]?[0-9]$/ ) {
        escape_tag( \$t );
        stop(
qq[   : ..  .   (,&nbsp; 12:01:20  15:30 (   ,   12:1:20)).<br><br> : &#147;$t&#148;]
        );
    }

    return $t;
}

sub sex_date {
    for (@_) { sec_date $_ }
}

sub sex_time {
    for (@_) { sec_time $_ }
}

sub sex_gt0 {
    for (@_) { sec_gt0 $_ }
}

sub sex_gteq0 {
    for (@_) { sec_gteq0 $_ }
}

sub sex_range {
    my $to   = pop;
    my $from = pop;
    for (@_) {
        sec_range( $_, $from, $to );
    }
}

our %FileLogs;

sub l {
    my $textlog = shift || '___EMPTY_STRING___';
    my $fname   = shift || '';
    my $fh;
    use IO::File;

    unless ( $FileLogs{$fname} ) {
        $fh = new IO::File ">> -log-$fname";
        $FileLogs{$fname} = $fh;
    }
    else {
        $fh = $FileLogs{$fname};
    }

    print $fh $textlog, "\n";
}

sub ll {
    open F, ">__log";
    print F shift;
    close F;
}

sub isadmin() {
    return ( ( defined($ggid) and ( $ggid == 1 || $ggid == 0 ) ) || $ACL{'1'} );
}

sub time2str {
    my $time_session_length = shift;
    my $time_str            = '';
    if ($time_session_length) {
        if ( $time_session_length > 3600 ) {
            $time_str =
              ( $time_session_length - ( $time_session_length % 3600 ) ) / 3600
              . "&nbsp; ";
            $time_session_length %= 3600;
        }
        if ( $time_session_length > 60 ) {
            $time_str .=
              ( $time_session_length - ( $time_session_length % 60 ) ) / 60
              . "&nbsp;. ";
            $time_session_length %= 60;
        }
        if ($time_session_length) {
            $time_str .= $time_session_length . "&nbsp;.";
        }
        $time_str = "$time_str";
    }
    else { $time_str = ''; }

    return $time_str;
}

sub filter_class {
    my $c = shift;
    my $date = shift || $gdate;

    if ($c) { sec_gt0 $c }

    my $q = sqlp "select
class_id, paralel ||' '||(select name from class where class_id = cast(sys_matrix.class as integer))
from sys_matrix, class
where class = class_id and
	sys_matrix.view_class = 7 and
	exists ( select 1 from get_node_saldo(sys_matrix.node_id, '$date', 0) where saldo_sum <> 0)";

    my %classes;
    my ( $filter_class, $selected, $id, $name, $name_orig );

    while ( ( $id, $name ) = $q->fetchrow_array() ) {
        $name_orig = $name;
        $name =~ s/\s+/ /go;
        $name =~ s/^(\d+\s{0,}".+").*/$1/o;
        $name =~ s/^(\d)(\D.*)/ $1$2/o;
        $name =~ s/"/&quot;/go;
        unless ( $classes{"$name"} ) {
            $classes{"$name"} = $id;
        }
        else {
            $name_orig =~ s/"/&quot;/go;
            $classes{"$name_orig"} = $id;
        }
    }

    for (
        sort {
            substr( $a, 0, 2 ) <=> substr( $b, 0, 2 )
              || substr( $a, 2 ) cmp substr( $b, 2 )
        } keys %classes
      )
    {

        $selected = ( $c == $classes{$_} ) ? 'selected' : '';

        if ($DEBUG) {
            $filter_class .=
"<option $selected value=\"$classes{$_}\">id=$classes{$_}&nbsp;&nbsp;$_</option>\n";
        }
        else {
            $filter_class .=
              "<option $selected value=\"$classes{$_}\">$_</option>";
        }

    }

    return $filter_class;
}

sub cms_uniq_permalink {
    my $permalink = shift;
    $permalink = trim($permalink);
    my $permalink_new = $permalink;
    my @table_id = ( shift, shift );

    if ( grep /^$permalink$/, @modules ) { $permalink_new = $permalink . '-2'; }
    if ( $permalink eq 'NULL' ) { return undef; }

    my @SQL = ( '', '' );
    if ( $table_id[0] && $table_id[0] eq 'content' ) {
        $SQL[0] = "c_id != '$table_id[1]' and";
    }
    elsif ( $table_id[0] && $table_id[0] eq 'news' ) {
        $SQL[1] = "news_id != '$table_id[1]' and";
    }

    my $tmp = 1;
    for ( my $j = 2 ; $tmp ; $j++ ) {
        $tmp = (
            sqlbfcms(
"SELECT 1 FROM content WHERE $SQL[0] permalink = ? union SELECT 1 FROM news WHERE $SQL[1] permalink = ?",
                $permalink_new,
                $permalink_new
            )
        )[0];

        if   ($tmp) { $permalink_new = $permalink . '-' . $j; }
        else        { $tmp           = 0; $permalink = $permalink_new; }
    }
    return $permalink;
}

sub sqlfh($) {
    my $sql = shift;
    return $gdb->selectrow_hashref($sql) or report_sql_error($sql);
}

sub sqlfhcms($) {
    my $sql = shift;
    return $gdbcms->selectrow_hashref($sql) or report_sql_error($sql);
}

sub find_tool {
    my $tool_name = shift;

    my %possible_names = (
        'htpasswd' => ['htpasswd2'],
        'isql'     => [ 'fbsql', 'isql-fb' ],
    );

    unless ( exists $possible_names{$tool_name} ) {
        return 0;
    }

    my @tool_name_variants;

    push @tool_name_variants, $tool_name;

    for ( @{ $possible_names{$tool_name} } ) {
        push @tool_name_variants, $_;
    }

    my @paths_to_search =
      ( '/usr/bin', '/usr/sbin', '/usr/local/bin', '/opt/firebird/bin', );

    for my $path (@paths_to_search) {
        for my $name (@tool_name_variants) {
            if ( -f "$path/$name" ) {
                return "$path/$name";
            }
        }
    }

    return 0;

}

sub sphelper_request($) {
    my $request = shift;

    use IO::Socket;

    my $socket = IO::Socket::INET->new(
        Proto    => "tcp",
        PeerAddr => $gconf{'sp_helper_host'}
          || '127.0.0.1', PeerPort => ( $gconf{'sp_helper_port'} || 7890 )
    ) or return undef;

    my $auth_part =
qq[<auth><user>$gconf{'db_user'}</user><password>$gconf{'db_pass'}</password></auth>];

    print $socket $auth_part . $request . "\n\n";

    local $_;
    while (<$socket>) {

        if (/^</) {
            return $_;
        }
    }

}

sub login($$$) {

    my $log         = shift;
    my $pwd         = shift;
    my $redirect_to = shift || '?act=main';

    Time::HiRes::sleep(0.5);

    if ( $ENV{'REQUEST_METHOD'} ne 'POST' ) {
        security_alert( $ENV{'REQUEST_METHOD'}, 'not POST' );
    }

    clear_expired_sessions();

    my $uid;
    my $sid;

    my $ip = $ENV{'REMOTE_ADDR'};
    $ip =~ s/'//g;
    my $ip_for = substr( $ENV{'HTTP_X_FORWARDED_FOR'} || '', 0, 40 );
    $ip_for =~ s/'//g;
    my $agent = substr( $ENV{'HTTP_USER_AGENT'}, 0, 127 );
    $agent =~ s/'//g;

    my $datetime = time;

    my $user_valid = 0;

    $log = substr( $log, 0, 64 );
    $pwd = substr( $pwd, 0, 64 );

    my ( $tmp_uid, $tmp_password ) =
      sqlfb( 'select uid, pas from sp_users where log = ?', $log );

    my $q;

    if ($tmp_uid) {
        unless (
            sqlff(
                "select 1 from sp_users, sp_gid_ref
				where uid = $tmp_uid and sp_users.gid = sp_gid_ref.gid"
            )
          )
        {
            stop("    .");
        }
    }

    if ( $tmp_uid and $tmp_password eq $pwd ) {
        $user_valid = 1;
    }
    elsif ($tmp_uid) {
        log_user_sesion( 7, $log, $pwd );
        error(
"    .  .<br><br>$login_form"
        );
    }

    if ($user_valid) {
        $uid = $tmp_uid;

        my $logged = 0;

        my @data;
        if ( @data =
            sqlf("select uid, sid from sp_users_logged where uid = $uid") )
        {
            $logged = 1;
        }

        unless ($logged) {
            my $fail = 1;
            my @data1;

            while ($fail) {
                $sid = int( rand(2147483644) ) + 1;

                $q = sqlp("select sid from sp_users_logged where sid = '$sid'");
                @data1 = $q->fetchrow_array();
                $q->finish;

                if ( !@data1 ) {
                    undef $fail;
                }
            }

            sql(
"INSERT INTO sp_users_logged (uid,logtime,lasttime,ip,ip_for,agent,sid)  VALUES
			('$uid', '$datetime', '$datetime', '$ip', '$ip_for', '$agent', '$sid')"
            );
        }
        else {
            my ( $IP, $IP_FOR, $AGENT, $SID ) = sqlf(
                "select
			IP,  IP_FOR,  AGENT,  SID
			from sp_users_logged WHERE uid = $uid"
            );

            my $sid_from_cookie = cookie("sp_sid");

            if (   $SID != $sid_from_cookie
                or $IP     ne $ip
                or $IP_FOR ne $ip_for
                or $AGENT  ne $agent )
            {

                sql(
                    "update
				sp_users_logged
			set
				IP     = '$ip',
				IP_FOR = '$ip_for',
				AGENT  = '$agent'
			where
				uid = $uid"
                );
            }

            sql(
"update sp_users_logged set lasttime = $datetime where sid = $data[1]"
            );

            my $sid_cookie = cookie(
                -name    => 'sp_sid',
                -value   => $SID,
                -expires => '+24h'
            );

            print redirect(
                -uri    => $redirect_to,
                -cookie => $sid_cookie
            );
            exit 0;

        }

        $guid = $uid;
        $ggid = sqlff("select gid from sp_users where uid = $uid");
        log_user_sesion( 1, $sid );

        my $sid_cookie = cookie(
            -name    => 'sp_sid',
            -value   => $sid || $tmp_uid,
            -expires => '+24h'
        );

        if ( $redirect_to =~ m/\?/ ) {
            $redirect_to .= qq[&logged_uid=$guid&logged_gid=$ggid];
        }

        print redirect(
            -uri    => $redirect_to,
            -cookie => $sid_cookie
        );
        exit 0;

    }
    else {

        log_user_sesion( 6, $log, $pwd );
        error(
"    .  .<br><br>$login_form"
        );

    }

}

sub ModulesSinhro {
    my $from = shift;
    my $uid  = shift;

    my $owner_tmp = $owner;

    my $gid_o;

    if ( $from eq 'sp' ) {
        $gid_o = gid($uid);

        $owner_tmp = $autor_insert = $uid;
    }
    else {
        $gid_o = gid_o();
    }

    my $zapros = "select i_id from modules where access like '%,$gid_o,%'";

    if ( isadmin() ) {
        $zapros = "select i_id from modules";
    }

    my $q = sqlpcms($zapros);

    my @mod_def;

    my @a;
    while ( @a = $q->fetchrow_array() ) {
        push( @mod_def, $a[0] );
    }

    if ( $from eq 'sp' ) {
        $zapros = "select mod_id from modules_cnf_users where owner = $uid";
    }
    else {
        if ( param('edt') and isadmin() and !$ACL{6} ) {
            $owner_tmp = $autor_insert = $guid;
        }

        $zapros =
          "select mod_id from modules_cnf_users where owner = $owner_tmp";
    }

    $q = sqlpcms($zapros);

    my @mod_real;
    while ( @a = $q->fetchrow_array() ) {
        push( @mod_real, $a[0] );
    }

    my %seen;
    my @mod_add;
    my $item;
    @seen{@mod_real} = ();
    foreach $item (@mod_def) {
        push( @mod_add, $item ) unless exists $seen{$item};
    }
    my $num_mod_add = @mod_add;

    if ( $num_mod_add ne '0' ) {
        foreach $item (@mod_add) {
            my $zapros =
"select i_id,m_place,show_on,m_config from modules where i_id = $item";
            my $q = $gdbcms->prepare($zapros) or db_error();
            $q->execute() or db_error();
            my @a;
            my %mod_data;
            while ( @a = $q->fetchrow_array() ) {
                $mod_data{'i_id'}     = $a[0];
                $mod_data{'m_place'}  = $a[1];
                $mod_data{'show_on'}  = $a[2];
                $mod_data{'m_config'} = $a[3];
            }
            sqlcms(
qq^INSERT INTO modules_cnf_users (owner, mod_id, published, m_place, show_on, m_config)
								VALUES ($owner_tmp,$mod_data{'i_id'},1,'$mod_data{'m_place'}','$mod_data{'show_on'}','$mod_data{'m_config'}')^
            );
        }

        if ( $from eq 'cms' and $owner_tmp ne '6' ) {

            unless ( -d "$theme_dir/Users_Themes" ) {
                mkdir "$theme_dir/Users_Themes"
                  or
                  error("     : $!");
            }

            unless ( -d "$theme_dir/Users_Themes/$owner" ) {
                mkdir "$theme_dir/Users_Themes/$owner"
                  or error("    : $!");
            }

        }
    }

    my $neSec = sqlffcms(
"select head from content where head = ' ' and owner = '$owner'"
    );
    if ( $neSec ne ' ' ) {
        my $chead     = ' ';
        my $date      = 'NOW';
        my $text      = ' ';
        my $published = '0';
        my $type      = '0';
        my $parent    = '0';

        sqlbcms(
            qq{ INSERT INTO content
				(HEAD, STARTDATE, ENDDATE, TEXT, PUBLISHED, AUTOR, OWNER, C_TYPE, PARENT)
				VALUES
				( ?, ?, ?, ?, ?, ?, ?, ?, ? ) },
            $chead, $date, $date, $text, $published, $autor_insert, $owner_tmp,
            $type,  $parent
        );

    }
}

sub half_year_enabled() {
    return sqlff
      qq[select F_INT from SP_SETTINGS where NAME = 'enable_half_year'];
}

sub max {
    my $max = shift(@_);
    foreach my $foo (@_) { $max = $foo if $max < $foo; }
    return $max;
}

sub min {
    my $min = shift(@_);
    foreach my $foo (@_) { $min = $foo if $min > $foo; }
    return $min;
}

our $g_server_encoding;

sub get_server_encoding() {
    return $g_server_encoding if ( defined $g_server_encoding );

    if ( exists $gconf{'server_encoding'} ) {
        return $gconf{'server_encoding'};
    }

    if (   ( defined $ENV{LANG} and $ENV{LANG} =~ m/koi8/io )
        or ( defined $ENV{LC_CTYPE} and $ENV{LC_CTYPE} =~ m/koi8/io ) )
    {
        $g_server_encoding = 'KOI8-R';
        return $g_server_encoding;
    }

    if (    ( -f '/etc/sysconfig/i18n' )
        and
        ( 0 == system('grep -q -i koi8 /etc/sysconfig/i18n > /dev/null 2>&1') )
      )
    {
        $g_server_encoding = 'KOI8-R';
        return $g_server_encoding;
    }

    $g_server_encoding = 'utf-8';
    return $g_server_encoding;
}

sub shorten_class($) {
    my $class_name = shift;
    $class_name =~ s/[^\w]+(\w)\b.+/$1/o;
    escape_tag( \$class_name );
    return ucfirst($class_name);
}

sub param_dexss_lim {
    my $param_name = shift;
    my $max_length = shift;

    my $text = param($param_name);
    escape_tag( \$text );
    return substr( $text, 0, $max_length );
}

1;
