/*
4.2 -> 4.2 fixed for alt linux only
*/

INSERT INTO MODULES (MODULENAME, VISIBLE_NAME, MODULEDIR, MODULEFILE, M_DEF_LINK, ACCESS, M_PLACE, SHOW_ON, M_CONFIG)
VALUES ('analytics', ' ', NULL, NULL, 'mod=analytics', ',6,2,4,', 'custom', ',AllPage,', NULL);

CREATE GENERATOR GEN_GRADUATES_ID;

CREATE TABLE GRADUATES (
    ID_G     SMALLINT NOT NULL,
    FIO      VARCHAR(128),
    YEAR_G   SMALLINT,
    CLASS    VARCHAR(64),
    MEDAL    SMALLINT,
    SUM_PUP  SMALLINT
);

CREATE INDEX GRADUATES_IDX1 ON GRADUATES (ID_G);
CREATE INDEX GRADUATES_IDX2 ON GRADUATES (MEDAL);
CREATE INDEX GRADUATES_IDX3 ON GRADUATES (YEAR_G);

SET TERM ^ ;

CREATE OR ALTER TRIGGER GRADUATES_BI FOR GRADUATES
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id_g is null) then
    new.id_g = gen_id(gen_graduates_id,1);
end
^

SET TERM ; ^
