/* 5.0 */

/*-----------------------------------------------
SMS-gate
-----------------------------------------------*/

/*  */
INSERT INTO SP_SETTINGS (name, f_char)
VALUES
(
	'sms-gate-sender',
	/* ########### - 11  */
      'School # 1'
);

/*-----------------------------------------------
-
-----------------------------------------------*/

insert into sp_settings (name, f_char) values ('squid_content_filter', 'off');

/*-----------------------------------------------
  
-----------------------------------------------*/

insert into sp_settings (name, f_char) values ('bell_cron_sound', 'std');

/*-----------------------------------------------
  
-----------------------------------------------*/

/*  */
CREATE TABLE SP_SITES_WHITELIST
(
	ID INTEGER NOT NULL,
	NAME VARCHAR(64)
);

/*  */
CREATE TABLE SP_SITES_WHITELIST_ITEMS
(
    ID INTEGER NOT NULL,
    LIST_ID INTEGER NOT NULL,
	/* RFC 1123    :     255  */
    SITE VARCHAR(255)
);

alter table SP_SITES_WHITELIST       add constraint PK_SP_SITES_WHITELIST       primary key (ID);
alter table SP_SITES_WHITELIST_ITEMS add constraint PK_SP_SITES_WHITELIST_ITEMS primary key (ID);

CREATE SEQUENCE GEN_SP_SITES_WHITELIST_ID;
CREATE SEQUENCE GEN_SP_SITES_WHITELIST_ITEMS_ID;

SET TERM ^ ;

CREATE OR ALTER TRIGGER SP_SITES_WHITELIST_BI FOR SP_SITES_WHITELIST
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_SP_SITES_WHITELIST_ID,1);
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER SP_SITES_WHITELIST_ITEMS_BI FOR SP_SITES_WHITELIST_ITEMS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_SP_SITES_WHITELIST_ITEMS_ID,1);
END
^

SET TERM ; ^

SET TERM ^ ;

/*      */
CREATE OR ALTER TRIGGER SP_SITES_WHITELIST_BD0 FOR SP_SITES_WHITELIST
ACTIVE BEFORE DELETE POSITION 0
AS
begin
  delete from SP_SITES_WHITELIST_ITEMS wi where wi.list_id = old.id;
end
^

SET TERM ; ^

update RDB$RELATIONS
set RDB$DESCRIPTION = '5.0'
where RDB$RELATION_NAME = 'SP_SETTINGS';
