/* 5.2 */

ALTER TABLE NEWS_CAT ALTER COLUMN OWNER TYPE INTEGER;
commit;

/*  */
INSERT INTO MODULES (MODULENAME, VISIBLE_NAME, M_DEF_LINK,    ACCESS,      M_PLACE, M_CONFIG)
VALUES ('gallery',  '',   'mod=gallery', ',6,', 'center', ',resize=1,resize-to=1280,');

/*  */
INSERT INTO MODULES (MODULENAME, VISIBLE_NAME, M_DEF_LINK, ACCESS, M_PLACE)
VALUES ('guestbook', ' ', 'mod=guestbook', ',6,,2,,4,', 'center');

CREATE GENERATOR GEN_GUESTBOOK_ID;

CREATE TABLE GUESTBOOK (
    ID         INTEGER NOT NULL,
    NAME       VARCHAR(128),
    TEXT       BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    POST_DATE  TIMESTAMP,
    PUBLISHED  SMALLINT DEFAULT 0,
    OWNER      INTEGER NOT NULL
);

ALTER TABLE GUESTBOOK ADD CONSTRAINT PK_GUESTBOOK PRIMARY KEY (ID);

SET TERM ^ ;

CREATE OR ALTER TRIGGER GUESTBOOK_BI FOR GUESTBOOK
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_GUESTBOOK_ID,1);
END
^

SET TERM ; ^

/* / */
